c
c     driver program for computing terrain corrections
c     using plouff's method 
c     and for computing free air and bouguer anomalies
c     r.godson,u.s.g.s.,denver,co.,october,1978
c     revised 12/83 for new input format of line 3 of the header
c
      character*1 head3(57)
      character*3 ans,ians,yes,no,y,n,hitc(5),hotc(5),phitc,photc
      character*4 itc,otc,citc,cotc,guu
      character*8 sta,meter,prjct
      character*2 imode
      character*50 infile,tfile,tfile1,pfile,nfile,gfile
      dimension ta(80),tb(80)
      equivalence(meter,head3(2)),(prjct,head3(10)),
     & (head3(46),phitc),(head3(54),photc),
     & (head3(42),citc),(head3(50),cotc),(head3(29),guu)
      data hitc/'   ','a-e','a-f','a-g','a-h'/
      data hotc/'a-x','e-x','g-x','h-x','i-x'/
      data yes/'yes'/,no/'no'/,in/15/,in1/14/,y/'YES'/,n/'NO'/,
     & icard/5/,iprint/6/,iout/16/,iout1/17/,iout2/18/,
     & itc/'itc='/,otc/'otc='/
      call hboug
      isw=1
      icnt=1
      il=0
      istcnt=0
      ipage=0
      icorr=0
      write(iprint,1000)
 1000 format(' enter input gravity filename: '\)
      read(icard,1100)infile
 1100 format(a)
      write(iprint,1200)
 1200 format(' enter two bouguer densities: '\)
      read(icard,*)dens1,dens2
      dr1=dens1/2.67
      dr2=dens2/2.67
      call bougenc(infile,pfile,nfile,gfile)
      open(unit=16,file=pfile,status='unknown')
      open(unit=18,file=gfile,status='unknown',form='unformatted')
      write(iprint,1400)
 1400 format(' do you want to create new computer terrain corrections',
     & '(yes or no)',/,' : '\)
      read(icard,1100) ans
      if(ans.eq.yes.or.ans.eq.y) go to 6
      write(iprint,1500)
 1500 format(' do you want to use existing terrain correction file',
     & '(yes or no)',/,' : '\)
      read(icard,1100) ans
      if(ans.eq.no.or.ans.eq.n) go to 10
c
c     use existing terrain correction file
c
      call terenc(infile,tfile,tfile1)
      write(iprint,1600)
 1600 format(' enter a 1 to use hand terrain corrections',/,
     & ' enter a 2 to use inner computer terrain corrections',
     & /,' : '\)
      read(icard,*) icor
      go to 7
c
c     create terrain correction file
c
    6 call tcprompt(icnt,dens2,infile,tfile,rrmin)
      write(iprint,1700)
 1700 format(' terrain corrections completed')
      write(iprint,1800)
 1800 format(' enter a 1 to use hand terrain corrections',/,
     & ' enter a 2 to use inner computer terrain corrections',/,
     & ' enter a 3 to stop so computer terrain corrections',
     & ' can be examined',/,' : '\)
      read(icard,*) icor
      icorr=icor
      if(icor.lt.1.or.icor.ge.3) go to 910
    7 open(unit=14,file=tfile,status='old',blank='zero')
      open(unit=17,file=nfile,status='unknown')
 1900 format(57a1)
 2000 format(80a1)
c
c     read headers of input and terrain correction file
c     and write headers to new standard gravity file
c
      open(unit=15,file=infile,status='old',blank='zero')
      read(in,2000)ta
      read(in,2000)tb
      read(in,1900) head3
      read(in1,2000) ta
      read(in1,2000) tb
      read(in1,1900) head3
      write(iout1,2000) ta
      write(iout1,2000) tb
      if(icorr.ne.0) then
      if(rrmin.ne..39.and.rrmin.ne..895.and.rrmin
     & .ne.1.53.and.rrmin.ne.2.615) then
      phitc=' '
      photc=' '
      else
      inum=ifix(rrmin+2.5)
      if(rrmin.eq.0.) inum=inum-1
      phitc=hitc(inum)
      photc=hotc(inum)
      endif
      citc=itc
      cotc=otc
      endif
      write(iout1,1900) head3
c
c     find out units of elevations
c
      imode='mt'
      if(head3(23).eq.'f'.or.head3(23).eq.'F') imode='ft'
      isw=2
c
c     find out units of observed gravity
c
      read(guu,2050) gu
 2050 format(f4.3)
      if(gu.ne..01.and.gu.ne..001) gu=.01
c
c     terrain correction file used
c
    8 if(gu.eq..01) then
      read(in,2300,end=900) sta,iyr,iday,itime,itz,flatd,flatm,flond,
     & flonm,iel,st,obsgr,tc1,tc2,spec,tide,spec2
      else
      read(in,2350,end=900) sta,iyr,iday,itime,itz,flatd,flatm,flond,
     & flonm,iel,st,obsgr,tc1,tc2,spec,tide,spec2
      endif
      read(in1,2100,end=900) tnear,tc2,tc3
 2100 format(16x,3f7.2)
      if(icor.eq.2) tc1=tnear
      istcnt=istcnt+1
c
c     write new standard gravity file
c
      ltd=ifix(flatd)
      ltm=ifix(flatm*100.+.5)
      lond=ifix(flond)
      lonm=ifix(flonm*100.+.5)
      if(gu.eq..01) then
      iobs=ifix(obsgr*100.+.5)
      else
      iobs=ifix(obsgr*1000.+.5)
      endif
      itc1=ifix(tc1*100.+sign(.5,tc1))
      itc2=ifix(tc2*100.+sign(.5,tc2))
      ispec=ifix(spec*100.+sign(.5,spec))
      itide=ifix(tide*100.+sign(.5,tide))
      if(gu.eq..01) then
      write(iout1,2200) sta,iyr,iday,itime,itz,ltd,ltm,
     & lond,lonm,iel,st,iobs,itc1,itc2,ispec,itide,spec2
 2200 format(a8,a2,a3,a4,i4,i3,3i4,i6,a2,i7,3i6,i5,a6)
      else
      write(iout1,2250) sta,iyr,iday,itime,itz,ltd,ltm,
     & lond,lonm,iel,st,iobs,itc1,itc2,ispec,itide,spec2
 2250 format(a8,a2,a3,a4,i4,i3,3i4,i6,a1,i8,3i6,i5,a6)
      endif
      go to 35
c
c     terrain correction file not used
c
   10 open(unit=15,file=infile,status='old',blank='zero')
      read(in,2000)ta
      read(in,2000)tb
      read(in,1900) head3
c
c     find out units of elevations
c
      imode='mt'
      if(head3(23).eq.'f'.or.head3(23).eq.'F') imode='ft'
c
c     find out units of observed gravity
c
      read(guu,2050) gu
      if(gu.ne..01.and.gu.ne..001) gu=.01
   15 if(gu.eq..01) then
      read(in,2300,end=900) sta,iyr,iday,itime,itz,flatd,flatm,flond,
     & flonm,iel,st,obsgr,tc1,tc2,spec,tide,spec2
 2300 format(a8,a2,a3,a4,i4,f3.0,f4.2,f4.0,f4.2,i6,a2,f7.2,
     & 3f6.2,f5.2,a6)
      else
      read(in,2350,end=900) sta,iyr,iday,itime,itz,flatd,flatm,flond,
     & flonm,iel,st,obsgr,tc1,tc2,spec,tide,spec2
 2350 format(a8,a2,a3,a4,i4,f3.0,f4.2,f4.0,f4.2,i6,a1,f8.3,
     & 3f6.2,f5.2,a6)
      endif
      istcnt=istcnt+1
c
c     compute gravity anomalies
c
   35 phi=flatd+(flatm*.01666667)
c
c     change elevations to meters
c
      if(imode.eq.'ft') then
      elev=float(iel)*.03048
      else
      elev=float(iel)*.01
      endif
      call grcor1(phi,elev,stdg,fa,boug,cc)
      faa=obsgr-stdg+fa
      terr=tc1+tc2
      boug2=boug-cc
      cbg1=((boug2+terr)*dr1)+faa
      cbg2=((boug2+terr)*dr2)+faa
      cc=-1.*cc*dr1
      boug=boug*dr1
      terr=terr*dr1
      ter1=tc1*dr1
      ter2=tc2*dr1
      ilatd=flatd
      ilond=flond
      il=il+1
      if(il.eq.1)call header1(ta,tb,head3,ipage,dens1,dens2,imode,iout)
      if(il.eq.40)il=0
      if(imode.eq.'ft') elev=elev*3.28084
c
c     write to disk file for later printing
   50 if(gu.eq..01) then
      write(iout,2400)prjct,sta,ilatd,flatm,ilond,flonm,elev,st,obsgr,
     & stdg,terr,boug,cc,spec,faa,cbg1,cbg2,spec2
 2400 format(1x,a8,':',a8,1x,i2,1x,f5.2,1x,i4,1x,f5.2,1x,f8.2,
     & 1x,a2,1x,'9',f8.2,'  9',f8.2,1x,f7.2,1x,f7.2,1x,f5.2,
     & 2(1x,f7.2),1x,2(1x,f7.2),1x,a6)
      else 
      write(iout,2450)prjct,sta,ilatd,flatm,ilond,flonm,elev,st,obsgr,
     & stdg,terr,boug,cc,spec,faa,cbg1,cbg2,spec2
 2450 format(1x,a8,':',a8,1x,i2,1x,f5.2,1x,i4,1x,f5.2,1x,f8.2,
     & 1x,a1,1x,'9',f9.3,' 9',f9.3,1x,f5.2,1x,f8.3,1x,f6.3,
     & 1x,f5.3,1x,f8.3,1x,2(1x,f8.3),a6)
      endif
c
c      write to disk file for input to gridding & posting programs
c
      obsgr=obsgr-80000.
      xlat=float(ilatd)+flatm/60.
      xlon=float(abs(ilond))+flonm/60.
      write(iout2) sta,xlon,xlat,faa,cbg1,elev,ter1,ter2,obsgr
      if(mod(il,5).ne.0) go to 60
      write(iout,2500)
 2500 format(' ')
   60 go to (15,8),isw
  900 write(iprint,2600) istcnt
 2600 format(i7,' stations processed')
      close(unit=15)
  910 close(unit=16)
      close(unit=18)
      if(isw.eq.2) close(unit=14)
      if(isw.eq.2) close(unit=17)
      stop
      end
      subroutine hboug
c
c     introductory statements for BOUGUER
c
      write(*,1000)
 1000 format(
     &'      Welcome to Program BOUGUER(Version 1.0)',
     &//,'      U.S. Geological Survey Open-File Report 88-644B',
     &/,'                        by'
     &/'      Richard H. Godson and Donald Plouff',
     &//,'      This program was developed by personnel of the',
     &/,'      U. S. Geological Survey Branch of Geophysics.',/)
      write(*,2000)
 2000 format(
     &'      Although this program has been extensively tested,',/,
     &'      the U.S. Geological Survey cannot guarantee that',/,
     &'      it will give accurate results for all applications'/,
     &'      nor that it will work on all computer systems.'/)
      pause'Hit Return to Continue'
      return
      end
      subroutine pdate(datetm)
      character*24 datetm
      integer*2 iyr,imon,iday,ihr,imin,isec,i100th
      call gettim(ihr,imin,isec,i100th)
      call getdat(iyr,imon,iday)
      write(datetm,100) imon,iday,iyr,ihr,imin,isec
  100 format(i2.2,':',i2.2,':',i4.4,' time ',
     & i2.2,':',i2.2,':',i2.2)
      return
      end
c***********************************************************************
c***********************************************************************
c***********************************************************************
c***********************************************************************
c****                                                                ***
c****                                                                ***
c****        UU    UU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UU    UU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UU    UU    SS          GG          SS                  ***
c****        UU    UU    SSSSSSSS    GG   GGG    SSSSSSSS            ***
c****        UU    UU          SS    GG    GG          SS            ***
c****        UUUUUUUU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UUUUUUUU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****                                                                ***
c****                                                                ***
c****                 BRANCH of REGIONAL GEOPHYSICS                  ***
c****                                                                ***
c****                                                                ***
c****  ****      *    *****    *     ****     ****    ***     ****   ***
c****  *   *    * *     *     * *    *   *    *   *  *   *   *       ***
c****  *   *   *****    *    *****   ****     ****   *   *   *       ***
c****  *   *   *   *    *    *   *   *        *  *   *   *   *       ***
c****  ****    *   *    *    *   *   *        *   *   ***     ****   ***
c****                                                                ***
c****                                                                ***
c****                        DENVER COLORADO                         ***
c****                                                                ***
c****                                                                ***
c****                           code and                             ***
c****                         modifications                          ***
c****                             by                                 ***
c****                          D. Dansereau                          ***
c****                                                                ***
c****                                                                ***
c***********************************************************************
c***********************************************************************
c***********************************************************************
c***********************************************************************
      subroutine grcor1(phi,elev,stdg,fa,boug,cc)
c
c  this routine will provide standard gravity correction values
c  origional code by GI Evenden & RR Wahl
c
c  input
c         phi     - latitude in degrees
c        elev     - elevation of station in meters
c
c  output
c        stdg     - standard gravity (1967) - 900000.00
 
c          fa     - free air correction
c        boug     - bouguer correction
c          cc     - curvature correction
 
c
      p=phi*phi*.0001
c
c  standard gravity calculations
c
      stdg=78031.843+p*(15727.66+p*(-15762.337+p*(
     & 6083.534+p*(-1089.748+p*69.43))))
c
c  free air correction calculations
c
      fa=elev*(.30877+p*(-.0013398+p*(.0013553+p*(
     & -.0005329+p*.0000911)))-elev*.072e-6)
c
c  curvature correction calculations
c
      cc=elev*(1.4639108e-3+elev*(4.449648e-14*elev-3.532715e-7))
c
c  bouguer correction calculations
c
      boug=-.1119*elev
c
c  end of correction calculations
c
      return
      end
c***********************************************************************
c***********************************************************************
c***********************************************************************
c***********************************************************************
c****                                                                ***
c****                                                                ***
c****        UU    UU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UU    UU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UU    UU    SS          GG          SS                  ***
c****        UU    UU    SSSSSSSS    GG   GGG    SSSSSSSS            ***
c****        UU    UU          SS    GG    GG          SS            ***
c****        UUUUUUUU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****        UUUUUUUU    SSSSSSSS    GGGGGGGG    SSSSSSSS            ***
c****                                                                ***
c****                                                                ***
c****                 BRANCH of REGIONAL GEOPHYSICS                  ***
c****                                                                ***
c****                                                                ***
c****  ****      *    *****    *     ****     ****    ***     ****   ***
c****  *   *    * *     *     * *    *   *    *   *  *   *   *       ***
c****  *   *   *****    *    *****   ****     ****   *   *   *       ***
c****  *   *   *   *    *    *   *   *        *  *   *   *   *       ***
c****  ****    *   *    *    *   *   *        *   *   ***     ****   ***
c****                                                                ***
c****                                                                ***
c****                        DENVER COLORADO                         ***
c****                                                                ***
c****                                                                ***
c****                           code and                             ***
c****                         modifications                          ***
c****                             by                                 ***
c****                          R. Sweeney                            ***
c****                          D. Dansereau                          ***
c****                                                                ***
c****                                                                ***
c***********************************************************************
c***********************************************************************
c***********************************************************************
c***********************************************************************
      subroutine header1(ta,tb,head3,ipage,dens1,dens2,imode,iout)
c
c  this subroutine provides the header stuff for the line printer
c
      character*1 head3(57)
      character*2 imode
      character*8 meter
      character*24 datetm
      dimension ta(80),tb(80)
10    ipage=ipage+1
      write(iout,11)ipage
11    format('1',54x,'BOUGUER GRAVITY DATA',43x,'page  ',i6,/)
      write(iout,15)ta
      write(iout,15)tb
15    format(1x,80a1)
      call pdate(datetm)
      write(iout,25)head3,datetm
25    format(1x,57a1,5x,'Date: ',a24,//)
      write(iout,30)imode,dens1,dens1,dens2
30    format(5x'STATION'9x,'L  O  C  A  T  I  O  N  S',9x,'G R A V I T',
     &' Y',9x,'C O R R E C T I O N S',9x,'A N O M A L I E S',/,
     &' IDENTIFICATION    LATITUDE  LONGITUDE    ELE   ST OBSERVED',
     &' THEORETICAL  TERRAIN BOUGUER CURV  SPECIAL  FREE  COMPLETE',
     &'-BOUGUER  SPEC',/,'   proj  sta-id    deg  min  deg   min  (in ',
     &a2,')',30x,'(d1=',f4.2,')',19x,'AIR   d1=',f4.2,' d2=',f4.2,
     &' FIELDS',/)
      return
      end
      subroutine bougenc(infile,pfile,nfile,gfile)
      character*(*) infile,pfile,nfile,gfile
      ic=index(infile,'.')
      pfile=infile(:ic)//'bou'
      nfile=infile(:ic)//'new'
      gfile=infile(:ic)//'pos'
      return
      entry terenc(infile,pfile,nfile)
      ic=index(infile,'.')
      pfile=infile(:ic)//'tc'
      nfile=infile(:ic)//'tcp'
      return
      end
          subroutine tcprompt(icnt,d2,fil1,fil2,rrmin)
c
c         prompting program for revised terrain correction program tcprog
c         r.godson,usgs,denver,colorado,5/78
c
          character*50 filn1,filn2,filn3,fil1,fil2
          data icard/5/,iprint/6/
          filn1=fil1
          go to (2,30),icnt
          write(iprint,1800)
1800      format(' enter input gravity file name: '\)
          read(icard,1100) filn1
1100      format(a)
          write(iprint,2000)
2000      format(' enter second density'\)
          read(icard,*) d2
2         write(iprint,1900)
1900      format(' enter 1 for repeat run of same area;',
     & 'otherwise a 0',/,' : '\)
          read(icard,*) ir
          if(ir.eq.1) go to 5
          write(iprint,1000)
1000      format(' enter lower right lat & long boundary of data',
     & '(deg & nearest 15 min)', /,' : '\)
          read(icard,*) latbd,latbm,lonbd,lonbm
          write(iprint,1200)
1200      format(' enter upper left lat & long boundary of data',
     & '(deg & nearest 15 min)', /,' : '\)
          read(icard,*) latud,latum,lonud,lonum
5         write(iprint,1400)
1400      format(' enter 0 if stations are above sea level & on land',/,
     & ' enter 1 if stations are on land & some are below sea level',/,
     & ' enter -1 if station elevations are depths',
     & ' of stations below sea level',/,
     & ' enter -2 if station elevations are',
     & ' depths of bottom below stations',/,' : '\)
          read(icard,*) negln
          if(negln.lt.-2.or.negln.gt.1) go to 900
          write(iprint,1600)
1600      format(' enter inner terrain data spacing(15 or 30)',/,' : '\)
          read(icard,*) inn
          if(inn.ne.15.and.inn.ne.30) go to 900
10        write(iprint,1500)
1500      format(' enter distance in km(e.g.,0.,.39,.895,1.53,2.615)',
     & 'where computer corrections start',/,' : '\)
          read(icard,*) rmin
          if(rmin.eq.0) go to 20
          jcirc=1
          jsign=0
          go to 30
20        jcirc=2
          jsign=1
          write(iprint,1700)
1700      format(' enter distance in km(e.g.,0.,.39,.895,1.53,2.615)',
     & 'where inner corrections end',/,' : '\)
          read(icard,*) rmin
          if(rmin.eq.0.) jsign=0
30        call terenc(filn1,filn2,filn3)
          rrmin=rmin
          fil2=filn2
          open(8,file=filn3,status='unknown')
          open(9,file=filn1,status='old',blank='zero')
          open(14,file=filn2,status='unknown')
          call tcprog(ir,d2,jsign,negln,inn,rmin,jcirc,latud,latum,
     & lonud,lonum,latbd,latbm,lonbd,lonbm)
          return
900       write(iprint,2100)
2100      format(' wrong answer to an instruction',
     & ' in subroutine tcprompt')
          if(icnt.lt.1) go to 910
          close(16)
910       stop
          end
      SUBROUTINE TCPROG(IRPT,D2,JSIGN,NEGLN,INN,RMIN1,JCIRC,
     1 LATUD,LATUM,LONUD,LONUM,LATBD,LATBM,LONBD,LONBM)
C
C     PLOUFF'S TERRAIN CORRECTION PROGRAM
C     MODIFIED BY R.GODSON,USGS,DENVER,COLORADO-5/78
C     TO INTEGRATE WITH DENVER'S REDUCTION PROGRAM AND THE
C     THE TERRAIN DATA AVAILABLE ON DISK FOR THE CONTERMINUOUS U.S.
C
      CHARACTER*3 HITC(5),HOTC(5),PHITC,PHOTC
      CHARACTER*4 PITC,POTC,CITC,COTC
      CHARACTER*50 FILNAM,FILNM1,FILNM2
C     DOUBLE PRECISION DENTS,DENTST
      CHARACTER*1 IDUM2(57)
      CHARACTER*2 IMODE
      CHARACTER*8 DENTS,DENTST
C     INTEGER ALFA,SIGNLT,SIGNLN,ALPHA,YES
      CHARACTER*1 ALFA,SIGNLT,SIGNLN,ALPHA,YES,NEG,IQUEST,IYES,ISTOP
      INTEGER*2 NUMS,INNER
      DIMENSION GV(500),GCEN(500),NUMS(500,13),GRAV(500,13),IDUM(20),
     1 IDUM1(20)
      COMMON /RAIN/TERH(500)
C      COMMON  /INR/INNER(500)
      COMMON /STATN/ DENTS(500),GSEA(500)
      COMMON /MINUS/NEGLND
      COMMON /PRMPT/ IFMTI(19),IFMTO(19)
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
      COMMON /BLK2/ SLATM(500),SLONM(500),AS(500),BS(500),ELS(500),
     1 BREA(6),LTM(500),LNM(500)
      COMMON /TRAK/C,CC,C2,E2,D2P,D2Q,D2S,D2W,D2X,PHI,TER,ELKM,TC2,
     1 TC1,DUM(16)
      COMMON /FLAG/ IFLAG(500)
      COMMON /IOFILE/ IR,IW,IPNCH
      EQUIVALENCE(IDUM2(46),PHITC),(IDUM2(54),PHOTC)
      EQUIVALENCE (IDUM2(42),CITC),(IDUM2(50),COTC)
      DATA PITC/'itc='/,POTC/'otc='/
      DATA HITC/'   ','a-e','a-f','a-g','a-h'/
      DATA HOTC/'a-x','e-x','g-x','h-x','i-x'/
      DATA YES,NEG,IQUEST,IDIFF,IMTC2 /'Y','-','*','DIFF',' OC2'/
      DATA ISTOP/'S'/,ALFA/' '/,NCLIM/500/,
     1 DEGR/1.745329E-2/,IDISK/14/
      DATA FILNAM/'TERR1.TMP'/,FILNM1/'TERR2.TMP'/,FILNM2/'TERR3.TMP'/
      IF(IRPT.EQ.1) GO TO 5
C
C     GET THE PROPER MAPS FOR THIS EXECUTION
C
      LAT1=LATUD*100+LATUM
      LON1=LONUD*100+LONUM
      LAT2=LATBD*100+LATBM
      LON2=LONBD*100+LONBM
      CALL GETMAPS(LAT1,LON1,LAT2,LON2,INN)
C
    5 IR=9
      IW=8
      IPNCH=7
      JSW=0
C
C     ATTACH THREE FILES OBTAINED BY GETMAPS
C
      OPEN(UNIT=10,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(UNIT=11,FILE=FILNM1,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(UNIT=12,FILE=FILNM2,STATUS='OLD',FORM='UNFORMATTED')
      IUTIL=0
      NTYPE=3
      IF(JSIGN.EQ.1) NTYPE=4
      NEGLND=NEGLN
      IF (D2 .EQ. 0.0) D2=2.5
      LABL=IMTC2
C
C     READ THREE HEADER RECORDS OF DENVER FORMAT
C
      READ(IR,101) IDUM
      READ(IR,101) IDUM1
      READ(IR,103) IDUM2
  101 FORMAT(20A4)
  103 FORMAT(57A1)
      IMODE='MT'
      IF(IDUM2(23).EQ.'f'.OR.IDUM2(23).EQ.'F') IMODE='FT'
      if(rmin1.ne..39.and.rmin1.ne..895.and.rmin1
     & .ne.1.53.and.rmin1.ne.2.615) then
      phitc=' '
      photc=' '
      else
      inum=ifix(rmin1+2.5)
      if(rmin1.eq.0.) inum=inum-1
      phitc=hitc(inum)
      photc=hotc(inum)
      endif
      citc=pitc
      cotc=potc
  799 ISW=0
      RMIN=RMIN1
      RAD1=10000.0                                                          0280
      RAD2=0.0                                                              0290
      ASMAX=0.0
C
C     READS 500 STATIONS AT A TIME
C
      DO 6  NS=1,NCLIM
   68 READ (IR,102,END=7) DENTST,LT,QT,LN,QN,IELSIS,TERH(NS)
  102 FORMAT (A8,13X,I3,F4.2,I4,F4.2,I6,9X,F6.2)
      PHI=DEGR*(LT+QT/6.0E1)
      C=COS(PHI)
      C2=C*C
C
C     CHANGE ELEVATIONS TO KILOMETERS
C
      IF(IMODE.EQ.'FT') THEN
      ELKM=FLOAT(IELSIS)*.03048*1.0E-3
      ELSE
      ELKM=FLOAT(IELSIS)*1.0E-5
      ENDIF
      JT=QT
      JN=QN
      SLATM(NS)=QT-JT
      SLONM(NS)=QN-JN
C ABSOLUTE VALUES USED FOR LATITUDE AND LONGITUDE
      LTM(NS)=60*IABS(LT)+JT
      LNM(NS)=60*IABS(LN)+JN
      IF (NEGLND .EQ. -2) ELKM=-ABS(ELKM)
      ELS(NS)=ELKM
C AS,BS -EW AND NS CONSTANTS FOR CONVERSION BETWEEN GEOGRAPHIC AND          0930
C RECTANGULAR COORDINATES (UNITS ARE KM/MINUTE).                            0940
      AS(NS)=C*(1.861656-6.343E-3*C2)
      BS(NS)= 1.861656+C2*(1.6E-4*C2-1.9028E-2)
      IF (AS(NS) .LT. ASMAX) GO TO 83
      ASMAX=AS(NS)
      BSMAX=BS(NS)
   83 GV(NS)=0.0
      GCEN(NS)=0.0
C      INNER(NS)=0
      GSEA(NS)=0.0
      IFLAG(NS)=0
      DENTS(NS)=DENTST
    6 CONTINUE
      NS=NCLIM+1
      ISW=1
    7 NS=NS-1
      IF(NS.EQ.0) GO TO 99
      CALL ARRNG(NTYPE,RAD1,RAD2,ASMAX,BSMAX,NS,IUTIL,RMIN1,
     1 JSIGN,INN,JCIRC,JSW)
      IF (IUTIL .EQ. 999) GO TO 99
      D2Q=D2/2.67
      D2X=6.670*(2.67-D2)/2.67
      JN=0
      DO 15 KS=1,NS
      A=D2X*GSEA(KS)
      GSEA(KS)=A
      FA=ABS(A)
      IF (FA .LT. 0.0001) GO TO 15
      JN=JN+1
      AS(JN)=A
      NUMS(JN,1)=KS
   15 CONTINUE
      IF (JN .EQ. 0) GO TO 12
      WRITE (IW,207) D2
  207 FORMAT ('1CONTRIBUTION OF WATER COMPARTMENTS TO TERRAIN CORRECTION
     1 AT A DENSITY OF',F8.3)
      KSF=5*(JN/5)
      IF (JN .LT. 5) GO TO 2
      DO 13 KS=5,JN,5
      KS1=KS-1
      KS2=KS-2
      KS3=KS-3
      KS4=KS-4
      IFA=NUMS(KS4,1)
      ISB=NUMS(KS3,1)
      ITC=NUMS(KS2,1)
      LEL=NUMS(KS1,1)
      JT=NUMS(KS,1)
   13 WRITE (IW,208) DENTS(IFA),AS(KS4),DENTS(ISB),AS(KS3),DENTS(ITC),
     1 AS(KS2),DENTS(LEL),AS(KS1),DENTS(JT),AS(KS)
  208 FORMAT (5(4X,A8,F8.3))
      IF (KSF .EQ. JN) GO TO 12
    2 KSF=KSF+1
      DO 14 KS=KSF,JN
      JT=NUMS(KS,1)
   14 WRITE (IW,208) DENTS(JT), GSEA(KS)
   12 IF(JSW.EQ.1) GO TO 22
      IF(ISW.EQ.0) WRITE (IW,210)NS
  210 FORMAT (13H1SUMMARY FOR , I4,' STATIONS')
      IF(ISW.EQ.1) WRITE(IW,212)
  212 FORMAT('1')
      IF (JCIRC-1) 62,63,9
    9 WRITE (IW,213)
  213 FORMAT ('  COMPUTER TERRAIN CORRECTIONS CARRIED FROM STATION')
      GO TO 69
   62 WRITE (IW,215) RAD1
  215 FORMAT ('  COMPUTER TERRAIN CORRECTIONS CARRIED FROM NON-CIRCULAR'
     1 ,' INNER RADIUS OF   ',F8.3)
      GO TO 69                                                              4820
   63 WRITE (IW,218) RAD1
  218 FORMAT ('  COMPUTER TERRAIN CORRECTIONS CARRIED FROM CIRCULAR'
     1 ,' INNER RADIUS OF   ',F8.3)
   69 WRITE (IW,219)      RAD2,D2,LABL
  219 FORMAT (3H TO,F8.3,' KILOMETERS. DENSITY OF 2.67 IS USED FOR ',
     1 'OC1 AND 'F6.3,' FOR COLUMN LABELED OC2.',/,' HAND=HAND TERR',
     2 'AIN CORRECTION. OC1,OC2=COMPUTER TC FROM THIS PROGRAM',
     3 '(NOT INCLUDING NEAR OR HAND)',/,
     4 ' NEAR= COMPUTER TC FOR INNER ZONE(IF LESS THAN 5.0).',
     5 ' NF=MAPS NEEDED BUT NOT FOUND',//,' NF  STATION  LATIT',
     5 'UDE  LONGITUDE ELEVATION  HAND  NEAR   OC1',3X,A4,'   STATION')
      JSW=1
      ICNT=7
      WRITE(IDISK,101) IDUM
      WRITE(IDISK,101) IDUM1
      WRITE(IDISK,103) IDUM2
   22 D2P=0.012774*D2
      D2S=0.012774*1.643
      D2W=0.012774*(D2-1.027)
      DO 53 KS=1,NS                                                         4920
      KGB=IFLAG(KS)
      ICNT=ICNT+1
      IF (ICNT .LT. 59) GO TO 30
      ICNT=1
      WRITE (IW,230) LABL
  230 FORMAT ('1NF  STATION  LATIT',
     1 'UDE  LONGITUDE ELEVATION  HAND  NEAR   OC1',3X,A4,'   STATION')
   30 ELEV=ELS(KS)
      IF (NEGLND .EQ. -2) ELEV=0.0
C
C     CHANGE ELEVATIONS BACK TO ORIGINAL UNITS
C
      IF(IMODE.EQ.'FT') THEN
      ELSIS=3280.84*ELEV
      ELSE
      ELSIS=ELEV*1000.
      ENDIF
      JT=LTM(KS)
      JN=LNM(KS)
      LT=JT/60
      LN=JN/60
      JT=JT-60*LT
      JN=JN-60*LN
      QT=JT+SLATM(KS)
      QN=JN+SLONM(KS)
      IF (LN.LT.0) LN=-LN
      IF (LT.LT.0) LT=-LT
      DENTST=DENTS(KS)
      TC=TERH(KS)                                                           5060
      TC1=GV(KS)
C
C     CHECK FOR DIFFERENCE BETWEEN HAND AND COMPUTER TC
C
      IF (JSIGN .EQ. 0) GO TO 26
C      TC2=TC-TC1
C      GCEN(KS)=0.0
      TC1=GV(KS)-GCEN(KS)
      KGB=KGB/2
      IF(IFLAG(KS).EQ.1) KGB=1
C      GO TO 25
   26 TC2=D2Q*TC1-GSEA(KS)
C      IF (IFPUN .EQ. 0) GO TO 25
C      JT=100.0*QT+0.5
C      JN=100.0*QN+0.5
C      IF (NFIG-1) 70,71,72
C   70 LEL=      ELSIS+0.5
C      GO TO 74
C   71 LEL= 10.0*ELSIS+0.5
C      GO TO 74
C   72 LEL=100.0*ELSIS+0.5
C   74 IF (LEL .LT. 0) LEL=LEL-1
C      ITC=100.0*TC+0.5
C      ITC1=100.0* TC1+0.5
C      ITCN=100.0*GCEN(KS)+0.5
C      ITC2=100.0* TC2+0.5
C      ALPHA=ALFA
C      IF (KGB .NE. 0) ALPHA=IQUEST
C
C     OUTPUT OF TERRAIN CORRECTIONS
C
C DENVER FORMAT
C
C      WRITE (IPNCH,401) DENTST,LT,JT,LN,JN,LEL,ITC,ITC1,ITC2,ALPHA
   25 IF (KGB .NE. 0) GO TO 51
      WRITE (IW,211) DENTST,LT,QT,LN,QN,ELSIS,TC,GCEN(KS),TC1,TC2,DENTST
  211 FORMAT (5X,A8,I3,F6.2,I5,F6.2,F9.2,F7.2,F6.2,2F7.2,2x,A8)
      GO TO 52
   51 WRITE (IW,224) KGB,DENTST,LT,QT,LN,QN,ELSIS,TC,GCEN(KS),TC1,TC2,
     1 DENTST
  224 FORMAT (1X,I2,2X,A8,I3,F6.2,I5,F6.2,F9.2,F7.2,F6.2,2F7.2,2x,A8)
   52 WRITE(IDISK,401) DENTST,TC,GCEN(KS),TC1,TC2
  401 FORMAT(A8,1X,4F7.2)
   53 CONTINUE
   99 IF(ISW.EQ.1) GO TO 799
      CLOSE(UNIT=8)
      CLOSE(UNIT=9)
      CLOSE(UNIT=10)
      CLOSE(UNIT=11)
      CLOSE(UNIT=12)
      IF(IUTIL.EQ.999) STOP
      CLOSE(UNIT=14)
      RETURN
      END                                                                   5170
      SUBROUTINE ARRNG(NTYPE,RAD1,RAD2,ASMAX,BSMAX,NS,IUTIL,RMIN1
     1 ,JSIGN,INN,JCIRC,JSW)
C     DOUBLE PRECISION DENTS,DENTST,RIF(4),RIL(4)
      CHARACTER*8 DENTS,DENTST
      DOUBLE PRECISION RIF(4),RIL(4)
      INTEGER*2 NUMS,INNER
      DIMENSION LATQ(2000),LONQ(2000),BEL(15,15),GV(500),DY(4),
     1 GCEN(500),DENTQ(3,2000),NUMS(500,13),GRAV(500,13),E(60,60),
     2 LCIRC(4),IE(60,60)
      COMMON /RAIN/TERH(500)
      COMMON /STATN/ DENTS(500),GSEA(500)
      COMMON /GIN/XC,YC,AC5,YS,YN,DY,   AREAB,GPA,GB,GBW,ARCSB,AC10
      COMMON /ELG/ELEV,ELST,RGR2,NGLD
      COMMON /MAP/ DENTQ,LATQ,LONQ
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
      COMMON /BLK2/ SLATM(500),SLONM(500),AS(500),BS(500),ELS(500),
     1 BREA(6),LTM(500),LNM(500)
      COMMON /ALOOP/    BL1,BLOKK,BLOKL,BLOK2,RMAX,RMED2,BC2K,BC2L,
     1 BC10,COMK,COML,E,BEL
      COMMON /JLOOP/MQ,LTQ,LNQ,LTNWQ,LNNWQ,KBQ,LBQ,MCB,NCB,MCB1,NCB1,
     1 KCIRC,LATNW(500),LATSE(500),LONNW(500),LONSE(500),
     2 LATSD(500),LONSD(500),MSS(500)
      COMMON /MINUS/NEGLND
C      COMMON  /INR/INNER(500)
      COMMON /IOFILE/ IR,IW,IPNCH
      DATA MLIM,DEGR,RADMH/2000,1.74533E-2,1.45444E-4/
      DATA IPRINT/6/
      rmin1=0.
      IMAP=0
      KCIRC=JCIRC
      GBW=0.0
      GB =0.0
      RGR=14.
      DO 92 NMAP=1,NTYPE                                                    1220
      IMAP=IMAP+1
C
C     GET MAP PARAMETER DATA
C
      CALL MAPPARM(IMAP,LATM,LONM,KCLAT,LCLON,KBLOK,
     1 LBLOK,RMAX,RMIN,RMED,KCIRC,KSEC)
      IF(IMAP.EQ.1.AND.INN.EQ.15) KCLAT=15
      IF(IMAP.EQ.1.AND.INN.EQ.15) LCLON=15
      IF(JSIGN.EQ.1.AND.NMAP.EQ.1) GO TO 25
C   24 IF (KCIRC .GT. -1 .AND. KCIRC.LT. 4) GO TO 26
C   25 WRITE (IW,226) KCIRC
C  226 FORMAT (' STOP. WRONG INNER JOIN SELECTION.',I5)
C      GO TO 91
C   26 IF (KCIRC .NE. 3) GO TO 22
C      IF (LC .EQ. 1 .OR. JSIGN .NE. 0) GO TO 25
C   27 IFHTC=1
C      KCIRC=2
      IF(JSIGN.EQ.0.OR.NMAP.EQ.4) GO TO 22
      IF(NMAP.EQ.3) GO TO 254
      KCIRC=2
      RMIN=0.
      GO TO 22
  254 DO 255 I=1,NS
      GCEN(I)=GV(I)-GCEN(I)
  255 CONTINUE
   22 SIGN= 1.0
C      IF ( NMAP .NE. 2) GO TO 81
C      IF (JSIGN .EQ. 0) GO TO 81
      GO TO 81
C SET PARAMETERS FOR DIFFERENCE OF TC'S
   25 IMAP=0
      SIGN=0.
      KCIRC=1
   81 RIF(NMAP)=RMIN
      RIL(NMAP)=RMAX
      LCIRC(NMAP)=KCIRC
    2 IF (RMIN-RAD1) 94,95,95
   94 RAD1=RMIN                                                             1290
   95 IF (RMAX .LE. RAD2) GO TO 97
      RAD2=RMAX
   97 RMAX2=RMAX*RMAX
      RMED2=RMED*RMED                                                       1340
      RMIN2=RMIN*RMIN                                                       1350
      RGR2=RGR*RGR                                                          1360
      MCB=KBLOK/KCLAT                                                       1380
      NCB=LBLOK/LCLON                                                       1390
      LTES=LBLOK-LCLON*NCB
      KTES=KBLOK-KCLAT*MCB
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
      CPNUM=MCB*NCB                                                         1400
      MCB1=MCB-1                                                            1410
      NCB1=NCB-1                                                            1420
      NJN=(60*LONM)/LCLON
      NIT=(60*LATM)/KCLAT
      KBQ=(60*LATM)/KBLOK
      LBQ=(60*LONM)/LBLOK
      BQM=LATM                                                              1490
      AQM=LONM                                                              1500
      BQD=BQM/60.0
      AQD=AQM/60.0
      KLCMP=KCLAT*LCLON                                                     1530
      COMP2=KLCMP                                                           1540
      COMP2=COMP2/3600.0
      BLOKK=KBLOK                                                           1560
      BLOKL=LBLOK                                                           1570
      BLOKK=BLOKK/60.0
      BLOKL=BLOKL/60.0
      BLOK2=BLOKK*BLOKL                                                     1580
      BL2K=0.5*BLOKK                                                        1590
      BL2L=0.5*BLOKL                                                        1600
      BLK2K=BL2K/BQM                                                        1620
      BLK2L=BL2L/AQM                                                        1630
C EDGE OF QUAD MINUS HALF-BLOCK IN MINUTES, FOR TESTING RMAX                1650
      QB2B=BQM-BL2K                                                         1660
      QA2B=AQM-BL2L                                                         1670
      COMK=KCLAT                                                            1690
      COML=LCLON                                                            1700
      CMK2=COMK/120.0
      CML2=COML/120.0
      BC2K=BL2K-CMK2                                                        1750
      BC2L=BL2L-CML2                                                        1760
      ARCSB=COMP2/BLOK2                                                     1770
      BQM60=60.0/BQM                                                        1780
      RMXAQ=RMAX/AQM                                                        1830
      IF (KSEC .EQ. 1) GO TO 44
      IF (KSEC .EQ. 60) GO TO 45
   44 BLK2K=60.0*BLK2K
      BLK2L=60.0*BLK2L
      NJN=NJN/60
      NIT=NIT/60
      KTES=LONM-NJN*LCLON
      LTES=LATM-NIT*KCLAT
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
      KBQ=KBQ/60
      LBQ=LBQ/60
      KTES=LATM-KBQ*KBLOK
      LTES=LONM-LBQ*LBLOK
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
      COMP2=3600.0*COMP2
      BLOK2=3600.0*BLOK2
      BL2K=60.0*BL2K
      BL2L=60.0*BL2L
      BLOKK=KBLOK
      BLOKL=LBLOK
      BC2K=60.0*BC2K
      BC2L=60.0*BC2L
      QB2B=BQM-BL2K
      QA2B=AQM-BL2L
      GO TO 46
   45 COMK=COMK/60.0
      COML=COML/60.0
      KTES=60*LONM-NJN*LCLON
      LTES=60*LATM-NIT*KCLAT
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
      KTES=60*LATM-KBQ*KBLOK
      LTES=60*LONM-LBQ*LBLOK
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
   46 BL1=KBQ-1
      AC10=0.5*COML*ASMAX
      BC10=0.5*COMK*BSMAX
      TEST=AC10*AC10+BC10*BC10
      IF (RMIN2 .GT. TEST .OR. KCIRC .EQ. 2) GO TO 82
      WRITE (IPRINT,223) RMIN
  223 FORMAT (' PROGRAM NOT WRITTEN TO INCLUDE CASE WHERE HALF OF COMPAR
     1TMENT DIAGONAL-LENGTH IS GREATER THAN INNER RADIUS ', F6.2)
      GO TO 91
   82 TEST=RMED-RMIN
C HALF DIAGONAL OF LARGEST BLOCK
      ADEL=(AC10*NCB)**2+(BC10*MCB)**2
      ADEL=SQRT(ADEL)
      IF (TEST .GT. ADEL) GO TO 84
      WRITE (IPRINT,224) RMIN,RMED
  224 FORMAT (' SELECTED RADII',2F8.2,' DO NOT LEAVE ROOM FOR BLOCKS')
      GO TO 91
C ERROR OF 0.001 MINUTE
   84 AC10=ASMAX/1000.0
      BC10=BSMAX/1000.0
      DO 9 IS=1,NS
      DO 65 M=1,13
      GRAV(IS,M)=0.0                                                        1880
   65 NUMS(IS,M)=0                                                          1890
      MSS(IS)=0                                                             1910
C      IF (KCIRC .EQ. 2 .AND. JSIGN .EQ. 0 .AND. IFHTC .EQ. 0)
C     1 TERH(IS)=0.0
C      INNER(IS)=0
      ST=(SLATM(IS)+LTM(IS))/60.0
      STIND=BQM60*ST+1.0
      SNIND=(SLONM(IS)+LNM(IS))/AQM+1.0
C NW CORNER OF QUAD IN WHICH STATION IS LOCATED IN INDEX SYSTEM.            1950
C STATIONS ALONG EAST AND SOUTH EDGES INCLUDED IN QUAD TO NORTHWEST.        1960
      LATSD(IS)=STIND
      LONSD(IS)=SNIND
      STR=DEGR*ST
      CS=COS(STR)
      SS=SIN(STR)
      S2=SS*SS
      BB=RMAX*(5.42656E-1+S2*(S2*9.32312E-6-5.50958E-3))
      BD=RMAX*CS*SS*(1.60260E-6-S2*5.38726E-9)*BB
      CN=BB-BD
      RBN=CN/BQM
      RBS=(BB+BD)/BQM
      LATSE(IS)=STIND-RBS+BLK2K
      LATNW(IS)=STIND+RBN   -BLK2K
      CN=CN*RADMH
      C2N=CN*CN
      CN=CS*(1.0-0.5*C2N)-SS*CN*(1.0-C2N*1.66666E-1)
      RAN=RMXAQ/(CN*(1.861656-6.343E-3*CN*CN))-BLK2L
      LONSE(IS)=SNIND-RAN
      LONNW(IS)=SNIND+RAN
    9 CONTINUE
      INFILE=IR+IMAP
      IF(IMAP.EQ.0) INFILE=IR+1
      DO 10 MQ=1,MLIM+1
C
C     READ MAP HEADER
C
   21 READ(INFILE,END=12)(DENTQ(ID,MQ),ID=1,3),LTDQ,LTMQ,LNDQ,LNMQ,
     1 KFATH,IMN,IMX
C     WRITE (IW,212)(DENTQ(ID,MQ),ID=1,3),LTDQ,LTMQ,LNDQ,LNMQ,
C    1 KFATH,IMN,IMX
C 212 FORMAT (1X,3A4,2I3,I4,I3,I8,2I5)
      NGLD=0
      IF (KFATH .LT. 38) GO TO 8
C NEGATIVE LAND ELEVATIONS NOT TO BE TREATED AS SEAWATER
      NGLD=1
      KFATH=KFATH-40
    8 IF (MQ .LT. MLIM) GO TO 800
      WRITE (IPRINT,217)(DENTQ(ID,MLIM),ID=1,3),MLIM
  217 FORMAT ('0 TOTAL MAPS EXCEEDED.  MAP ',3A4,' IS NUMBER',I3)
      GO TO 91
C
C     READ MAP ELEVATIONS ONE MAP AT A TIME
C
  800 READ (INFILE)((IE(J,I),J=1,NJN),I=1,NIT)
  801 DO 307 I=1,NIT
      DO 307 J=1,NJN
  307 E(J,I)=IE(J,I)*1.0E-3
C      IF (KFATH-31) 300,306,306
C  300 DO 301 J=1,NJN
C      DO 301 I=1,NIT
C  301 E(I,J)=0.3048006*E(I,J)
C      IF (KFATH-6) 305,302,305
C  306 IF (KFATH-33) 308,305,309
C  302 DO 304 J=1,NJN
C      DO 304 I=1,NIT
C      EIJ=E(I,J)
C      IF (EIJ) 303,304,304
C  303 E(I,J)=6.0*EIJ
C  304 CONTINUE
C      GO TO 305
C  308 DO 310 J=1,NJN
C      DO 310 I=1,NIT
C      EIJ=E(I,J)
C      IF (EIJ) 312,310,310
C  312 E(I,J)=0.3048006*EIJ
C  310 CONTINUE
C      GO TO 305
C  309 DO 311 J=1,NJN
C      DO 311 I=1,NIT
C      EIJ=E(I,J)
C      IF (EIJ) 313,311,311
C  313 E(I,J)=1.8288036*EIJ
C  311 CONTINUE
  305 DO 86 K=1,KBQ
      KF=MCB*K                                                              2520
      K1=KF-MCB1                                                            2530
      DO 86 L=1,LBQ                                                         2540
      LF=NCB*L                                                              2550
      L1=LF-NCB1                                                            2560
      ELEV=0.0                                                              2570
      CPDN1=CPNUM                                                           2580
      DO 30 II=K1,KF                                                        2590
      DO 30 JJ=L1,LF                                                        2600
      EIJ=E(JJ,II)                                                          2610
C PROTECTION AGAINST BLANK ELEVATIONS                                       2620
      IF (EIJ) 54,31,54                                                     2630
   31 CPDN1=CPDN1-1.0                                                       2640
      GO TO 30                                                              2650
   54 ELEV=ELEV+EIJ                                                         2660
   30 CONTINUE                                                              2670
      IF (CPDN1) 32,32,85                                                   2680
   32 BEL(K,L)=0.0                                                          2690
      GO TO 86                                                              2700
   85 BEL(K,L)=ELEV/CPDN1                                                   2710
      IF(BEL(K,L).EQ.0.0) BEL(K,L)=0.0001
   86 CONTINUE                                                              2720
      LTNWQ=60*LTDQ+LTMQ
      LNNWQ=60*LNDQ+LNMQ                                                    2750
C NW CORNER OF QUAD IN INDEX UNITS OF ONE-PER-QUAD
      LATQ(MQ)=LTNWQ/LATM                                                   2790
      LONQ(MQ)=LNNWQ/LONM                                                   2800
      LTQ=LATQ(MQ)                                                          2810
      LNQ=LONQ(MQ)                                                          2820
      LTES=LTNWQ-LTQ*LATM
      KTES=LNNWQ-LNQ*LONM
      IF (LTES .NE. 0 .OR. KTES .NE.0) GO TO 99
      IF (MQ .EQ. 1.OR.INN.EQ.30) GO TO 3
      LESS=MQ-1
      DO 4 K=1,LESS
      IF (LTQ .EQ. LATQ(K) .AND. LNQ .EQ. LONQ(K)) GO TO 5
    4 CONTINUE
      GO TO 3
    5 WRITE (IW,206)
  206 FORMAT (' THIS MAP WAS SKIPPED. IT ALREADY HAS BEEN USED.')
      GO TO 21
    3 CALL LOOP(NS)
   10 CONTINUE
      GO TO 12
   99 WRITE(IPRINT,229)KCLAT,LCLON,KBLOK,LBLOK,LATM,LONM,LTDQ,
     1 LTMQ,LNDQ,LNMQ
  229 FORMAT (1X,2I3,3X,2I4,3X,2I4,4X,2I3,I5,I3/, 4X, 'STOP. ABOVE LISTE
     1D COMPARTMENT, BLOCK, MAP SIZES OR NORTHWEST CORNER OF MAP DO NOT
     2PROGRESS BY INTEGER MULTIPLICATION.')
      GO TO 91
   12 NQ=MQ-1                                                               4410
      REWIND INFILE
      IF(JSW.EQ.1) GO TO 55
      IF (KCIRC-1) 52,33,36
   36 WRITE (IW,219)     RMAX
  219 FORMAT ('0COVERAGE FOR ZERO TO',F9.3,' KILOMETERS')
      GO TO 53
   33 WRITE (IW,200)RMIN,RMAX
  200 FORMAT ('0MAP COVERAGE FOR ',F8.3,' TO ',F8.3,' KILOMETERS ',
     1 '(CIRCULAR INNER JOIN)')
      GO TO 53
   52 WRITE (IW,209)RMIN,RMAX
  209 FORMAT ('0MAP COVERAGE FOR ',F8.3,' TO ',F8.3,' KILOMETERS ',
     1 '(PIECEMEAL INNER JOIN)')
   53 IF (KSEC .EQ. 60) GO TO 48
      WRITE (IW,204)KCLAT,LCLON,KBLOK,LBLOK
  204 FORMAT (' COMPARTMENTS DIGITIZED ARE',I3,' BY',I3,' AND COMPOSITE'
     1 ,' BLOCKS ARE',I3,' BY',I3,' MINUTES')
      GO TO 50
   48 WRITE (IW,205)KCLAT,LCLON,KBLOK,LBLOK
  205 FORMAT (' COMPARTMENTS DIGITIZED ARE',I3,' BY',I3,' AND COMPOSITE'
     1 ,' BLOCKS ARE',I3,' BY',I3,' SECONDS')
   50 WRITE (IW,207)LATM,LONM,RMED,RGR
  207 FORMAT(49H IN LATITUDE AND LONGITUDE. QUADRANGLES USED ARE , I3,
     24H BY , I3,9H MINUTES.,26H  CONVERSION TO BLOCKS AT ,F7.2,4H KM./,
     3  25H CURVATURE CORRECTION AT ,F5.1,' KM.',//)
C      IF (IFHTC  .EQ. 1) WRITE (IW,214)
C  214 FORMAT (' HAND TC IS ADDED, THOUGH COMPUTER JOIN IS TO STATION.')
   55 DO 90 IS=1,NS                                                         4540
C      IN=INNER(IS)
      DENTST=DENTS(IS)
      A=AS(IS)                                                              4710
      B=BS(IS)                                                              4720
      CALL DEXQD(IS,LATNW(IS),LONNW(IS),BQD,AQD,LATSE(IS),LONSE(IS),
     1 LATSD(IS),LONSD(IS),NQ,MSS(IS),LATM,LONM,SIGN,DENTST)
   90 CONTINUE                                                              4750
   92 CONTINUE                                                              4760
      IF(JSW.EQ.1) GO TO 666
      WRITE (IW,201)
  201 FORMAT (///,'0LIST OF RADIAL COVERAGE FOR SUCCESSIVE MAP SETS',/,
     1 '  INNER BOUNDARY IS PIECEMEAL UNLESS CIRCULAR IS INDICATED. ',
     2 'ALL OUTER BOUNDARIES ARE PIECEMEAL')
      DO 6 J=1,NTYPE
      IF(LCIRC(J) .NE. 1) GO TO 7
      WRITE (IW,215)  RIF(J),RIL(J)
  215 FORMAT (1X,F10.5,' TO ',F10.5,' KM (CIRCULAR INNER JOIN)')
      GO TO 6
    7 WRITE (IW,216)  RIF(J),RIL(J)
  216 FORMAT (1X,F10.5,' TO ',F10.5,' KM')
    6 CONTINUE
  666 RETURN
   91 IUTIL=999
      RETURN
      END
      SUBROUTINE MAPPARM(NMAP,LATM,LONM,KCLAT,LCLON,KBLOK,
     1 LBLOK,RMAX,RMIN,RMED,KCIRC,KSEC)
      GO TO(10,20,30),NMAP
   10 LATM=15
      LONM=15
      KCLAT=30
      LCLON=30
      KBLOK=60
      LBLOK=60
      RMAX=5.0
      RMED=4.0
      KSEC=60
      RETURN
   20 LATM=15
      LONM=15
      KCLAT=1
      LCLON=1
      KBLOK=3
      LBLOK=3
      RMAX=21.
      RMIN=5.0
      RMED=14.
      KCIRC=0
      KSEC=1
      RETURN
   30 LATM=60
      LONM=120
      KCLAT=3
      LCLON=3
      KBLOK=12
      LBLOK=12
      RMAX=166.7
      RMIN=21.
      RMED=60.
      KCIRC=0
      KSEC=1
      RETURN
      END
      SUBROUTINE LOOP(NS)
C     DOUBLE PRECISION DENTS
      CHARACTER*8 DENTS
      INTEGER*2 NUMS
      DIMENSION GCEN(500),LATQ(2000),LONQ(2000),BEL(15,15),
     1 GV(500),DY(4),DENTQ(3,2000),NUMS(500,13),GRAV(500,13),E(60,60)
      COMMON /STATN/ DENTS(500),GSEA(500)
      COMMON /GIN/XC,YC,AC5,YS,YN,DY,   AREAB,GPA,GB,GBW,ARCSB,AC10
      COMMON /ELG/ELEV,ELST,RGR2,NGLD
      COMMON /MAP/ DENTQ,LATQ,LONQ
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
      COMMON /BLK2/ SLATM(500),SLONM(500),AS(500),BS(500),ELS(500),
     1 BREA(6),LTM(500),LNM(500)
      COMMON /ALOOP/    BL1,BLOKK,BLOKL,BLOK2,RMAX,RMED2,BC2K,BC2L,
     1 BC10,COMK,COML,E,BEL
      COMMON /JLOOP/MQ,LTQ,LNQ,LTNWQ,LNNWQ,KBQ,LBQ,MCB,NCB,MCB1,NCB1,
     1 KCIRC,LATNW(500),LATSE(500),LONNW(500),LONSE(500),
     2 LATSD(500),LONSD(500),MSS(500)
      COMMON /MINUS/NEGLND
      COMMON  /TRNG/AC53,BC53,DYN,DYS,AREAC,BC5,NEGTST
      COMMON /FLAG/ IFLAG(500)
      COMMON /IOFILE/ IR,IW,IPNCH
      DEGR=  1.745329E-2
      DEGR28=0.125*DEGR*DEGR
      DEGR24=0.25 *DEGR*DEGR
      GC=0.0
C CONSTANT IN TERRAIN CORRECTION FORMULA.  DISTANCES IN KM.  GRAVITY IN     0400
C MGALS. DENSITY IS 2.67                                                    0410
      GP=2.67*6.670
C PARAMETERS FOR NORTH AND SOUTHMOST BLOCK ROWS OF MAP
      QT=LTNWQ
      DEGTOP=(QT-BL2K)/60.0
      CQS=COS(DEGR*DEGTOP)
      C2=CQS*CQS
      BT=1.861656+C2*(0.000160*C2-0.019028)
      AT=CQS*(1.861656-0.006343*C2)
      DEGBOT=     (QT-BQM+BL2K)/60.0
      CQS=COS(DEGR*DEGBOT)
      C2=CQS*CQS
      BB=1.861656+C2*(0.000160*C2-0.019028)
      AB=CQS*(1.861656-0.006343*C2)
      ADELR=(AB-AT)/BL1
      BDELR=(BB-BT)/BL1
C COMPUTATION OF TERRAIN CORRECTION FOR ONE QUAD, ONE STATION AT A TIME     2990
      DO 13 IS=1,NS                                                         3000
C DETERMINE IF QUAD IS TO BE USED. FIRST OMIT STATIONS WHERE QUAD OCCURS    3010
C OUTSIDE BORDER OF RMAX-RECTANGLE.  SEQUENCE N, S, W, E.                   3020
      IF (  LTQ   -LATNW(IS)) 14,14,13                                      3030
   14 IF (  LTQ   -LATSE(IS)) 13,15,15                                      3040
   15 IF (  LNQ   -LONNW(IS)) 16,16,13                                      3050
   16 IF (  LNQ   -LONSE(IS)) 13,17,17                                      3060
C LATITUDE AND LONGITUDE OF STATION IN MINUTES                              3070
   17 ST=SLATM(IS)+LTM(IS)
      SN=SLONM(IS)+LNM(IS)
      DEGS=ST/60.0
      DEGN=SN/60.0
C DIFFERENCE IN LOCATION BETWEEN NW QUAD CORNER AND STATION, IN MINUTES     3110
      QTST=(LTNWQ-LTM(IS))-SLATM(IS)
      QNSN=(LNNWQ-LNM(IS))-SLONM(IS)
      QTS2B=QTST-BL2K                                                       3140
      QNS2B=QNSN-BL2L                                                       3150
      QQNB=QNSN-QA2B                                                        3160
      QQTB=QTST-QB2B                                                        3170
C INDEX UNITS FOR CORNER OF QUAD IN WHICH STATION LOCATED                   3180
      LTS=LATSD(IS)                                                         3190
      LNS=LONSD(IS)                                                         3200
C TEST IF QUAD OUTSIDE RMAX RADIUS SQUARED                                  3210
      IF (LTQ-LTS) 19,22,20
   19 DPHI2=(DEGS-DEGTOP)**2
      AQ2=(0.5*(AT+AS(IS))*(1.0+DEGR28*DPHI2))**2
      BQ2=(0.5*(BT+BS(IS)))**2
      IF (LNQ-LNS) 21,22,23
   20 DPHI2=(DEGS-DEGBOT)**2
      AQ2=(0.5*(AB+AS(IS))*(1.0+DEGR28*DPHI2))**2
      BQ2=(0.5*(BB+BS(IS)))**2
      IF (LNQ-LNS) 24,22,25
C SE, SW, NE, NW
   21 DISQ2=BQ2*QTS2B*QTS2B+AQ2*QNS2B*QNS2B                                 3290
      GO TO 26                                                              3300
   23 DISQ2=BQ2*QTS2B*QTS2B+AQ2*QQNB*QQNB                                   3320
      GO TO 26                                                              3330
   24 DISQ2=BQ2*QQTB*QQTB+AQ2*QNS2B*QNS2B                                   3350
      GO TO 26                                                              3360
   25 DISQ2=BQ2*QQTB*QQTB+AQ2*QQNB*QQNB                                     3380
C TEST RMAX                                                                 3390
   26 IF (DISQ2-RMAX2) 22,13,13                                             3400
   22 BCOMK=BS(IS)*COMK
      ACOML=AS(IS)*COML
      MS=MSS(IS)+1
      IF (MS-14) 72,71,71
   71 WRITE (IW,220)DENTS(IS),DEGS,DEGN,(DENTQ(ID,MQ),ID=1,3),
     & LTNWQ,LNNWQ
  220 FORMAT (' STATION ',A8,2F8.3,' NEEDS MORE THAN 13 MAPS',
     1 /,8X,' MAP ', 3A4,2I6,' NEEDED BUT NOT COMPUTED.')
      IFLAG(IS)=IFLAG(IS)+1
      GO TO 13
   72 MSS(IS)=MS
      NUMS(IS,MS)=MQ                                                        3520
      ELST=ELS(IS)
      RC5=(0.5*SQRT(BCOMK*BCOMK+ACOML*ACOML)+RMIN)**2
      NEGTST=0
      IF (ELST .LT. 1.0E-5 .AND. NEGLND .LT. 0)  NEGTST=NEGLND
      IF (NEGTST .EQ. -2) ELST=0.0
      DPHI2=(DEGS-DEGTOP)**2
      ATOP=0.5*(AT+AS(IS) *(1.0+DEGR24*DPHI2))
      BTOP=0.5*(BT+BS(IS))
      DPHI2=(DEGS-DEGBOT)**2
      ABOT=0.5*(AB+AS(IS) *(1.0+DEGR24*DPHI2))
      BBOT=0.5*(BB+BS(IS))
      ADEL =(ABOT-ATOP)/BL1
      BDEL =(BBOT-BTOP)/BL1
      A=ATOP-ADEL
      B=BTOP-BDEL
      AROW=AT-ADELR
      BROW=BT-BDELR
C START LOOP FOR TESTING BLOCKS OF COMPARTMENTS NORTH TO SOUTH
      IFLAGB=0
      IFLAGC=0
      DO 41 I=1,KBQ
      KF=MCB*I                                                              3620
      K1=KF-MCB1                                                            3630
      FK1=I-1                                                               3640
C FOR DISTANCES OF STATION TO BLOCK ROW
      B=B+BDEL
      A=A+ADEL
C FOR DISTANCES WITHIN BLOCK ROW
      AROW=AROW+ADELR
      BROW=BROW+BDELR
      DISTN=B*(QTS2B-FK1*BLOKK)                                             3650
      IF (DISTN .GE. RMAX) GO TO 41
C BLOCK AREA IN SQUARE KILOMETERS
      AREAB=AROW*BROW*BLOK2
      AREAC=ARCSB*AREAB
      BCOMK=BROW*COMK
      ACOML=AROW*COML
C CONSTANT IN TERRAIN CORRECTION FORMULA
      GPA=AREAB*GP
      AC5=0.5*ACOML
      BC5=0.5*BCOMK
      AC53=AC5+ACOML-AC10
      BC53=BC5+BCOMK-BC10
C EAST TO WEST
      DO 40 L=1,LBQ                                                         3660
      LF=NCB*L                                                              3670
      L1=LF-NCB1                                                            3680
      FL1=L-1                                                               3690
      DISTW=A*(QNS2B-FL1*BLOKL)
      R2B=DISTN*DISTN+DISTW*DISTW                                           3830
      IF (R2B-RMAX2) 28,40,40                                               3840
   28 IF (R2B-RMED2) 34,29,29                                               3850
C USE LARGE BLOCKS. AVERAGE THE ELEVATIONS OF COMPARTMENTS.                 3860
   29 ELEV=BEL(I,L)                                                         3870
      IF (ELEV .NE. 0.0) GO TO 87
      WRITE (IW,211)  I, L,DENTS(IS)
  211 FORMAT (' WARNING. BLOCK',      I3,'S,',I3,'E HAS ZERO ELEVATION.'
     1,' TC NEEDED BUT NOT CALCULATED FOR STATION ',A8)
      IFLAGB=IFLAGB+1
      GO TO 40
   87 CALL GR(R2B,GB,GBW)
      GO TO 39                                                              3940
C USE SMALL COMPARTMENTS.  DISTANCES RELATIVE TO CENTER OF COMPARTMENT      3950
C IN NW CORNER OF BLOCK.                                                    3960
   34 DISNC=DISTN+BROW*BC2K
      DISWC=DISTW+AROW*BC2L
      FJI=0.0                                                               3990
      GB=0.0                                                                4000
      GBW=0.0
      DO 35 II=K1,KF                                                        4010
      FIJ=0.0                                                               4020
      YC=DISNC-FJI*BCOMK                                                    4030
      YC2=YC*YC                                                             4040
C DISTANCE, IN KM, FROM STATION  TO NORTH AND S EDGES OF COMPARTMENT        4050
      DYN=YC+BC5                                                            4060
      DYS=YC-BC5                                                            4070
      IF (ABS(DYN) .LT. BC10) DYN=0.0
      IF (ABS(DYS) .LT. BC10) DYS=0.0
      YN=DYN*DYN                                                            4080
      YS=DYS*DYS                                                            4090
      DY(1)=DYN                                                             4100
      DY(2)=DYN                                                             4110
      DY(3)=DYS                                                             4120
      DY(4)=DYS                                                             4130
      DO 78 JJ=L1,LF                                                        4140
      ELEV=E(JJ,II)                                                         4160
      IF (ELEV .NE. 0.0) GO TO 38
      WRITE (IW,214) II,JJ,DENTS(IS)
  214 FORMAT (' WARNING. COMPARTMENT',I3,'S,',I3,'E HAS ZERO ELEVATION.'
     1,' TC NEEDED BUT NOT CALCULATED FOR STATION ',A8)
      IFLAGC=IFLAGC+1
      GO TO 78
   38 XC=DISWC-FIJ*ACOML
      XC2=XC*XC                                                             4210
      RC=XC2+YC2                                                            4220
C RC5 IS RMIN PLUS 0.5* SLANT LENGTH OF COMPARTMENT                         4230
C TEST IF THIS MAP GROUP REQUIRES INNER TIE TO CIRCLE                       4240
      IF (KCIRC-1) 51,49,27
C
C     COMPUTE TC INTO THE STATION
C
   27 CALL TRIANG(RC,IS)
      GO TO 78
   49 IF (RC .LT. RC5) GO TO 64
   51 IF (RC-RMIN2) 78,37,37                                                4270
   37 CALL GR(RC,GC,GW)
      GBW=GBW+GW*ARCSB
      GB=GB+GC*ARCSB
      GO TO 78                                                              4300
   64 CALL GINNER(RC)
   78 FIJ=FIJ+1.0                                                           4330
      FJI=FJI+1.0                                                           4340
   35 CONTINUE                                                              4350
   39 GRAV(IS,MS)=GRAV(IS,MS)+GB*GPA
      GSEA(IS)=GSEA(IS)+GBW*AREAB
   40 CONTINUE                                                              4370
   41 CONTINUE
      IF (IFLAGB .NE. 0 .OR. IFLAGC .NE. 0) IFLAG(IS)=IFLAG(IS)+1
C END STATION LOOP
   13 CONTINUE                                                              4390
      RETURN
      END
      SUBROUTINE DEXQD(IS,LT,LN,BQD,AQD,LTSE,LNSE,LTS,LNS,NQ,     MS,
     1                       LATM,LONM,SIGN,DENTST)
C     DOUBLE PRECISION DENTST
      CHARACTER*8 DENTST
      INTEGER*2 NUMS
      DIMENSION IQ(5,7),GCEN(500),GRAV(500,13),GV(500),DENTM(3,13),
     1 DENTQ(3,2000),NUMS(500,13),         LATQ(2000),LONQ(2000),
     2 LTDQ(13),LTMQ(13),LNDQ(13),LNMQ(13)
      COMMON /TRAK/A2,B2,FK,FL,QA,QB,QN,QT,QNNW,QNSN,QTNW,QTST,DISQ2
     1 ,DUM(17)
      COMMON /MAP/ DENTQ,LATQ,LONQ
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
      COMMON /BLK2/ SLATM(500),SLONM(500),AS(500),BS(500),ELS(500),
     1 BREA(6),LTM(500),LNM(500)
      COMMON /FLAG/ IFLAG(500)
      COMMON /IOFILE/ IR,IW,IPNCH
      DO 41 K=1,5
      DO 41 L=1,7
   41 IQ(K,L)=0
      QTNW=LT
      QNNW=LN
      QTNW=BQD*QTNW
      QNNW=AQD*QNNW
      QB=60.*QTNW
      QA=60.*QNNW
C REFERENCE TO NW CORNER OF QUADS.
      KMAX=LT-LTSE+1
      LMAX=LN-LNSE+1
      KSM1=LT-LTS
      LSM1=LN-LNS
      KSP1=KSM1+2
      LSP1=LSM1+2
      DO 42 K=1,KMAX
      DO 42 L=1,LMAX
   42 IQ(K,L)=IQ(K,L)+2
      A2=AS(IS)**2
      B2=BS(IS)**2
      ST=SLATM(IS)+LTM(IS)
      SN=SLONM(IS)+LNM(IS)
C S-E-N-W EDGES
      QTS2B=ST+BL2K
      QNS2B=SN+BL2L
      QTST=ST+QB2B
      QNSN=SN+QA2B
C NW-NE-SW-SE CORNERS
      IF (KSM1) 152,152,156
  156 IF (LSM1) 158,158,157
  157 DO 49 K=1,KSM1
      QT=B2*(QB-(K-1)*BQM-QTST )**2
      DO 44 L=1,LSM1
      QN=QA-(L-1)*AQM-QNSN
      DISQ2=      QT+A2*QN*QN
      IF (DISQ2-RMAX2) 44,44,43
   43 IQ(K,L)=IQ(K,L)-2
   44 CONTINUE
   49 CONTINUE
  158 IF (LMAX-LSP1) 152,151,151
  151 DO 51 K=1,KSM1
      QT=B2*(QB-(K-1)*BQM-QTST )**2
      DO 46 L=LSP1,LMAX
      QN=QA-(L-1)*AQM-QNS2B
      DISQ2=      QT+A2*QN*QN
      IF (DISQ2-RMAX2) 46,46,45
   45 IQ(K,L)=IQ(K,L)-2
   46 CONTINUE
   51 CONTINUE
  152 IF (KMAX-KSP1) 155,153,153
  153 IF (LSM1) 159,159,160
  160 DO 55 K=KSP1,KMAX
      QT=B2*(QB-(K-1)*BQM-QTS2B)**2
      DO 48 L=1,LSM1
      QN=QA-(L-1)*AQM-QNSN
      DISQ2=      QT+A2*QN*QN
      IF (DISQ2-RMAX2) 48,48,47
   47 IQ(K,L)=IQ(K,L)-2
   48 CONTINUE
   55 CONTINUE
  159 IF (LMAX-LSP1) 155,154,154
  154 DO 56 K=KSP1,KMAX
      QT=B2*(QB-(K-1)*BQM-QTS2B)**2
      DO 50 L=LSP1,LMAX
      QN=QA-(L-1)*AQM-QNS2B
      DISQ2=      QT+A2*QN*QN
      IF (DISQ2-RMAX2) 50,50,149
  149 IQ(K,L)=IQ(K,L)-2
   50 CONTINUE
   56 CONTINUE
  155 CONTINUE
      GB=0.
      M=0
      IF (MS) 53,53,54
   54 DO 132 MQ=1,MS
      M  =NUMS(IS,MQ)
      LTQ=LATQ(M)
      LNQ=LONQ(M)
      LTB=LATM*LTQ
      LNA=LONM*LNQ
      LTD=LTB/60
      LND=LNA/60
      LTDQ(MQ)=LTD
      LTMQ(MQ)=LTB-60*LTD
      LNDQ(MQ)=LND
      LNMQ(MQ)=LNA-60*LND
      LTS=LT-LTQ+1
      LNS=LN-LNQ+1
      IQ(LTS,LNS)=IQ(LTS,LNS)-1
      DENTM(1,MQ)=DENTQ(1,M)
      DENTM(2,MQ)=DENTQ(2,M)
      DENTM(3,MQ)=DENTQ(3,M)
C
C     TERRAIN CORRECTION
C
  132 GB=GB+GRAV(IS,MQ)
      GV(IS)=GV(IS)+GB*SIGN
      IF(SIGN.EQ.0.) GCEN(IS)=GCEN(IS)+GB
C      IF (IFPRNT .EQ. 0) GO TO 53
C      WRITE (IW,205) DENTST,IS,GB,GCEN(IS),IN
C  205 FORMAT (1X,A8,' (',I3,') SET TC IS',F7.3,' MGAL',6X,'GCEN=',
C     1 F7.3,'  INNER=',I2)
C      IF (IFPRNT .NE. 2) GO TO 53
C      IF (MS-1) 53,134,52
C   52 MS5=MS/2
C      MS2=2*MS5
C      MSM=MS-MS2
C      DO 93 M=2,MS2,2
C      M1=M-1
C   93 WRITE (IW,204)(DENTM(ID,M1),ID=1,3), LTDQ(M1),LTMQ(M1),LNDQ(M1),
C     1 LNMQ(M1),GRAV(IS,M1), (DENTM(ID,M),ID=1,3),LTDQ(M),LTMQ(M),
C     2 LNDQ(M),LNMQ(M),GRAV(IS,M)
C  204 FORMAT (2X,2(3A4,I6,I3,I8,I3, F11.3,6X))
C      IF (MSM .EQ. 0) GO TO 53
C  134 WRITE (IW,207)(DENTM(ID,MS),ID=1,3),LTDQ(MS),LTMQ(MS),LNDQ(MS),
C     1 LNMQ(MS),GRAV(IS,MS)
C  207 FORMAT (2X,3A4,I6,I3,I8,I3,F11.3)
   53 LTB=LT*LATM
      LNA=LN*LONM
      DO 138 K=1,5
      DO 136 L=1,7
      IF (IQ(K,L)-2) 136,137,136
  137 LTMIN=LTB-LATM*(K-1)
      LNMIN=LNA-LONM*(L-1)
      LTDEG=LTMIN/60
      LNDEG=LNMIN/60
      LTS  =LTMIN-60*LTDEG
      LNS  =LNMIN-60*LNDEG
      DO 2 M=1,NQ
      MQ=M
      LTD=LATM*LATQ(M)
      IF (LTD .NE. LTMIN) GO TO 2
      LND=LONM*LONQ(M)
      IF (LND .EQ. LNMIN) GO TO 136
    2 CONTINUE
      IFLAG(IS)=IFLAG(IS)+1
      WRITE (IW,209) DENTST,IS,LTDEG,LTS,LNDEG,LNS
  209 FORMAT (' ****STATION ',A8,' (',I4,')*MAP NOT FOUND', I6,I3,I8,I3)
  136 CONTINUE
  138 CONTINUE
      RETURN
      END
      SUBROUTINE GR (R2,G,GW)
      COMMON /MINUS/NEGLND
      COMMON /ELG/H,   E,   RGR2,NGLD
C AREAC BROUGHT IN FOR POSSIBLE TEST OF RC/AREAC FOR USE OF PRISM
      COMMON  /TRNG/AC53,BC53,DYN,DYS,AREAC,BC5,NEGTST
C DETERMINE TERRAIN CORRECTION FOR COMPARTMENT.   H,E- ELEVATION OF         0020
C COMPARTMENT AND STATION IN KM.    R2- SQUARE OF DISTANCE IN KM.  RGR2-    0030
C TEST RADIUS FOR USE OF CURVATURE CORRECTION. MASS LINE FORMULAS.
C MULTIPLICATION BY 2.67*6.670*AREA IN SUBROUTINE ARRNG
      RP2=1.0/R2                                                            0050
      HKM=E-H                                                               0070
      HE2=HKM*HKM                                                           0080
      HR2=HE2*RP2                                                           0090
      IF (H .LT. 0.0) GO TO 14
    1 GW=0.0
      RP=SQRT(RP2)
      IF (RGR2 .GT. R2) GO TO 5
C CURVATURE ACCOUNTED FOR.  MODIFIED LINE ELEMENT FORMULA.                  0120
      C2=R2/6371.2
      G=0.5*HKM*RP*RP2                                                      0150
      FG=HKM+C2                                                             0160
      IF (HR2-0.013) 4,4,3                                                  0170
    3 FG=FG-0.75*HKM*HR2                                                    0180
    4 G=G*FG                                                                0190
      RETURN
C NO CURVATURE, LINE ELEMENT FORMULA.
    5 IF (HR2-0.41) 7,6,6
    6 G=RP*(1.0-1.0/SQRT(1.0+HR2))                                          0280
      RETURN
    7 G=0.5*RP*HR2                                                          0300
      IF (HR2-0.006) 13,13,8
    8 FG=1.0-0.75*HR2                                                       0320
      IF (HR2-0.09) 12,12,9
    9 HR4=HR2*HR2                                                           0340
      FG=FG+0.625*HR4                                                       0350
      IF (HR2-0.21) 12,12,10
   10 FG=FG-0.546875*HR2*HR4                                                0370
      IF (HR2-0.32) 12,12,11
   11 FG=FG+0.4921875*HR4*HR4                                               0390
   12 G=G*FG                                                                0400
   13 RETURN
   14 IF (NGLD   .EQ. 1) GO TO 1
      IF (NEGLND .EQ. 1) GO TO 1
C SEAWATER COMPARTMENTS
      IF (RGR2 .GT. R2) GO TO 18
      G=R2/12742.4
      ED=HKM+G
      D=ED*ED*RP2
      FG=D*(0.5-D*(0.375-0.3125*D))
      ED=  E+G
      D=ED*ED*RP2
      RP=SQRT(RP2)
      GW=1.027*RP*(FG-D*(0.5-D*(0.375-0.3125*D)))
      D=G*G*RP2
      G=RP*(FG-D*(0.5-D*(0.375-0.3125*D)))-GW/2.67
      RETURN
C SEAWATER WITHOUT CURVATURE
   18 D=HR2
      C2=RP2*AREAC
      IF (G  .GT. 9000.0 .OR. C2 .LT. 0.2 ) GO TO 19
      G=0.0
      IF (G .NE. 0.0) RETURN
   19 C2=E*E
      IF (H .GT. E) D=C2*RP2
      RP=SQRT(RP2)
      IF (D .LT. 0.41 ) GO TO 20
      ED=1.0/SQRT(1.0+RP2*C2)
      D=1.0/SQRT(1.0+HR2)
      GW=1.027*RP*(ED-D)
      G =RP*(1.0-D)-GW/2.67
      RETURN
   20 IF (D .GT. 0.006) GO TO 21
      RP=RP*RP2
      ED=HE2
      GW=0.5135*RP*(ED-C2)
      G =0.5*RP*ED-GW/2.67
      RETURN
   21 D=HR2
      FG=             D*(0.5-D*(0.375-0.3125*D*(1.0-0.875 *D)))
      D= C2*RP2
      GW=1.027*RP*(FG-D*(0.5-D*(0.375-0.3125*D*(1.0-0.875 *D))))
      G =RP*FG-GW/2.67
      RETURN
      END                                                                   0750
      SUBROUTINE GINNER(RC)
C     DOUBLE PRECISION DENTS
      CHARACTER*8 DENTS
      INTEGER*2 NUMS,INNER
      DIMENSION GRAV(500,13),NUMS(500,13),GV(500),DY(4),GCEN(500)
      DIMENSION DX(4),R2(4)
C      COMMON /INR/INNER(500)
      COMMON /STATN/ DENTS(500),GSEA(500)
      COMMON /GIN/XC,YC,AC5,YS,YN,DY,   AREAB,GPA,GB,GBW,ARCSB,AC10
      COMMON /ELG/ELEV,ELST,RGR2,NGLD
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
      COMMON /IOFILE/ IR,IW,IPNCH
      is=0.
      DXW=XC+AC5
      DXE=XC-AC5                                                            0110
      IF (ABS(DXW) .LT. AC10) DXW=0.0
      IF (ABS(DXE) .LT. AC10) DXE=0.0
      XW=DXW*DXW                                                            0120
      XE=DXE*DXE                                                            0130
      DX(1)=DXW                                                             0140
      DX(2)=DXE                                                             0150
      DX(3)=DXE                                                             0160
      DX(4)=DXW                                                             0170
      R2(1)=XW+YN                                                           0180
      R2(2)=XE+YN                                                           0190
      R2(3)=XE+YS                                                           0200
      R2(4)=XW+YS                                                           0210
      BIG=0.0
C     NPT-NUMBER OF CORNERS OF COMPARTMENT THAT ARE LOCATED
C OUTSIDE RMIN CIRCLE
      NPT=0
      DO 320 K=1,4                                                          0250
      IF (RMIN2 .GE. R2(K)) GO TO 320
      NPT=NPT+1
      IF (BIG   .GE. R2(K)) GO TO 320
      KBIG=K                                                                0340
      BIG=R2(K)
  320 CONTINUE                                                              0280
      IF (NPT .EQ. 0) RETURN
C ASSIGN COORDINATES (X2,Y2) TO CORNER FARTHEST FROM STATION                0360
      Y2=DY(KBIG)                                                           0370
      X2=DX(KBIG)                                                           0380
      XM=0.0
      YM=0.0
      GC=0.0
      GW=0.0
      AREA =0.0
      AREAR=0.0
      I1=1                                                                  0450
      I2=1                                                                  0460
      IF (X2 .LT. 0.0) I1=-1
      IF (Y2 .LT. 0.0) I2=-1
      KTEST=0
      S1=DXW*DXE
      IF (S1 .GE. 0.0) GO TO 337
      S1=DY(1)*DY(4)
      IF (S1 .LT. 0.0) KTEST=1
  337 S1=I1
      S2=I2
C COORDINATES OF CORNER CLOSEST TO STATION (OPPOSITE FARTHEST CORNER)
      KSML=KBIG+2
      IF (KSML .GT. 4) KSML=KBIG-2
      X1=DX(KSML)
      Y1=DY(KSML)
C CALCULATE ACCORDING TO HOW MANY CORNERS ARE OUTSIDE CIRCLE
      GO TO (322,323,324,325), NPT
C ONE CORNER OUTSIDE CIRCLE
  322 CALL CENTD(0.0,X2,0.0,Y2,S1, S2,AREA,YM,XM,1)
C ASSUME 0.002-MINUTE LOCATION ACCURACY
      ABAR=ABS(AREA)
      IF(ABAR .LT. 1.0E-5) RETURN
      RBAR2=(YM*YM+XM*XM)/(ABAR*ABAR)
      IF (RBAR2 .LT. R2(KBIG)) GO TO 406
      RBAR2=R2(KBIG)
      ELEV=ELST+SQRT(RBAR2/RC)*(ELEV-ELST)
      GO TO 405
C TWO POINTS OUTSIDE CIRCLE.
C FIND COORDINATES OF SECOND CORNER OUTSIDE CIRCLE-ADJACENT FARTHEST
  323 LBIG=KBIG+1
      IF (LBIG .EQ. 5) LBIG=1
      IF (R2(LBIG) .GT. RMIN2) GO TO 65
      LBIG=KBIG-1
      IF (LBIG .EQ. 0) LBIG=4
   65 IF (DY(KBIG) .EQ. DY(LBIG)) GO TO 342
C REVERSED ROLES
      IF (Y1) 376,343,377
  376 LY1=-1
      GO TO 367
  377 LY1=1
  367 L3=I2+LY1
      IF (L3 .EQ. 0) GO TO 368
  343 CALL CENTD(Y1,Y2,0.0,X2,S2, S1,AREA,XM,YM,2)
      GO TO 403
  342 IF (X1) 346,344,347
  346 LX1=-1                                                                0850
      GO TO 351                                                             0860
  347 LX1=1                                                                 0870
  351 L4=I1+LX1
      IF (L4 .EQ. 0) GO TO 349
  344 CALL CENTD(X1,X2,0.0,Y2,S1, S2,AREA,YM,XM,2)
      GO TO 403                                                             0940
C X1 AND X2 ARE OF OPPOSITE SIGN  (368 FOR OPP. Y1, Y2)                     0950
  349 IF (RMIN-ABS(Y2)) 344,344,330
  368 IF (RMIN-ABS(X2)) 343,343,330
C 3 CORNERS OUTSIDE CIRCLE
  324 IF (R2(KSML) .EQ. RMIN2) GO TO 37
      IF (Y1) 51,52,53
   51 LY1=-1
      GO TO 354                                                             1100
   52 LY1= 0
      GO TO 354
   53 LY1= 1
  354 L3=I2+LY1+3
      IF (X1) 5,6,7
    5 LX1=-1
      GO TO 8
    6 LX1= 0
      GO TO 8
    7 LX1= 1
    8 L4=I1+LX1+3
      GO TO (101,102,103,102,101), L3
  101 GO TO (355,121,104,121,355), L4
  355 CALL CENTD(X1,0.0,Y1,0.0,S1,S2,AREA,YM,XM,3)
      GO TO 400                                                             1160
  121 CALL CENTD(Y1,0.0,0.0,0.0,S2,S1,AREA,XM,YM,6)
      GO TO 400
  122 CALL CENTD(X1,0.0,0.0,0.0,S1,S2,AREA,YM,XM,6)
      GO TO 400
  104 IF (ABS(Y2) .GE. RMIN) GO TO 355
   15 LBIG=KBIG+1
      IF (LBIG .EQ. 5) LBIG=1
      IF (DX(LBIG) .EQ. DX(KBIG)) GO TO 108
      LBIG=KBIG-1
      IF (LBIG .EQ. 0) LBIG=4
  108 CALL CENTD(Y1,Y2,0.0,X2,S2, S1,AREA,XM,YM,2)
      GO TO 114
  102 GO TO (122,105,106,105,122), L4
  105 AREA=0.7853982*RMIN2
      BIG=RMIN*RMIN2/3.0
      YM=S1*BIG
      XM=S2*BIG
      GO TO 400
  106 IF (ABS(Y2) .LT. RMIN) GO TO 15
      GO TO 122
  103 GO TO (111,112,113,112,111), L4
  111 IF (ABS(X2) .LT. RMIN) GO TO 12
      CALL CENTD(Y1,0.0,X1,0.0,S2,S1,AREA,XM,YM,3)
      GO TO 400                                                             1190
  112 IF (ABS(X2) .GE. RMIN) GO TO 121
   12 LBIG=KBIG+1
      IF (LBIG .EQ. 5) LBIG=1
      IF (DY(LBIG) .EQ. DY(KBIG)) GO TO 109
      LBIG=KBIG-1
      IF (LBIG .EQ. 0) LBIG=4
  109 CALL CENTD(X1,X2,0.0,Y2,S1, S2,AREA,YM,XM,2)
  114 LR=10-(KBIG+LBIG+KSML)
      CALL CENTD (0.0,DX(LR),0.0,DY(LR),0.0,0.0,AREAR,XE,XW,1)
      GO TO 115
  113 IF (ABS(X2) .LT. RMIN) GO TO 107
      IF (ABS(Y2) .LT. RMIN) GO TO 15
      CALL CENTD(X1,X2,Y1,Y2,S1, S2,AREA,YM,XM,5)
      AREAR=AREA
      GO TO 115
  107 IF (ABS(Y2) .GE. RMIN) GO TO 12
      LBIG=KBIG+1
      IF (LBIG .EQ. 5) LBIG=1
      LR=10-(KBIG+LBIG+KSML)
      CALL CENTD (0.0,DX(LR),0.0,DY(LR),0.0,0.0,AREAR,XE,XW,1)
      GO TO 110
  330 AREAR=0.0
  110 CALL CENTD (0.0,DX(LBIG),0.0,DY(LBIG),0.0,0.0,AREA,XE,XW,1)
      AREAR=AREAR+AREA
      CALL CENTD (0.0,X2,0.0,Y2,S1,S2,AREA,YM,XM,1)
  115 AREAR=AREAR+AREA
      ABAR=ABS(AREAR)
      RBAR2=(XM*XM+YM*YM)/(AREA*AREA)
      GO TO 405
C 4 CORNERS OUTSIDE CIRCLE
  325 IF (X1) 54,37,55
   54 LX1=-1
      GO TO 56
   55 LX1= 1
   56 L3=I1+LX1
      IF (L3 .NE. 0) GO TO 366
      IF (Y1) 57,37,58
   57 LY1=-1
      GO TO 59
   58 LY1= 1
   59 L4=I2+LY1
      IF (L4 .EQ. 0) RETURN
      IF (ABS(Y1) .GE. RMIN) GO TO 37
      CALL CENTD(0.0,0.0,Y1,0.0,0.0,S2,AREA,YM,XM,4)
      GO TO 400                                                             1400
  366 IF (Y1) 16,37,17
   16 LY1=-1
      GO TO 18
   17 LY1= 1
   18 L4=I2+LY1
      IF (L4 .NE. 0) GO TO 37
C REVERSED ROLES                                                            1410
      IF (ABS(X1) .GE. RMIN) GO TO 37
      CALL CENTD(0.0,0.0,X1,0.0,0.0,S1,AREA,XM,YM,4)
C MOMENT OF RECTANGULAR COMPARTMENT.                                        1500
  400 AREAR=ABS((X2-X1)*(Y2-Y1))
      AREA =AREAR-AREA                                                      1520
C MOMENTS ABOUT Y- AND X-AXES FOR REMAINING AREA                            1530
      YM=XC*AREAR-YM                                                        1540
      XM=YC*AREAR-XM                                                        1550
  403 ABAR=ABS(AREA)                                                        1560
      RBAR2=(YM*YM+XM*XM)/(ABAR*ABAR)
  406 ELEV=ELST+SQRT(RBAR2/RC)*(ELEV-ELST)
  405 GC=99999.9
      CALL GR(RBAR2,GC,GW)
      ABAR=ABAR/AREAB
      GC=GC*ABAR
      GW=GW*ABAR
      BIG=GC*GPA
C      IF (KTEST .EQ. 1) WRITE (IW,200) DENTS(IS),BIG
C  200 FORMAT (1X,'STATION ',A8,' IS INSIDE CALCULATED COMPARTMENT. ',
C     1 'CORRECTION IS',F8.3,' MGAL.')
C      GCEN(IS)=GCEN(IS)+BIG
C      INNER(IS)=INNER(IS)+1
      GO TO 9
   37 CALL GR(RC,GC,GW)
      GC=GC*ARCSB
      GW=GW*ARCSB
    9 GB=GB+GC
      GBW=GBW+GW
      RETURN
      END
      SUBROUTINE CPRISM(JTS)
C PRISM FORMULA TO CALCULATE GRAVITY EFFECT OF COMPARTMENT IN WHICH
C STATION IS LOCATED.
      COMMON  /CPR/X1,X2,Y1,Y2,H1,H2,A1,A2,XX1,XX2,YY1,T1,T2,T3,T4,DU
      COMMON /TRAK/YY2,R11,R12,R21,R22,HH,H10,H20,H02,H01,S11,S12,S21,
     1S22,XY11,XY12,XY22,XY21,SH10,SH20,SH02,SH01,Y1S11,Y1S21,Y2S22,
     2 Y2S12,X1S11,X1S12,X2S22,X2S21
      XX1=X1*X1
      XX2=X2*X2
      YY2=Y2*Y2
      YY1=Y1*Y1
      XY11=XX1+YY1
      XY12=XX1+YY2
      XY22=XX2+YY2
      XY21=XX2+YY1
      R11=SQRT(XY11)
      R12=SQRT(XY12)
      R22=SQRT(XY22)
      R21=SQRT(XY21)
      T1=(Y1+R11)*(Y2+R12)/XX1
      T2=(Y1+R21)*(Y2+R22)/XX2
      T3=(X1+R11)*(X2+R21)/YY1
      T4=(X1+R12)*(X2+R22)/YY2
      ISTART=0
      IF (JTS .EQ. 1) GO TO 2
C VALUES FOR INTEGRAL TO ELST
      H=H1
    3 ISTART=1+ISTART
      HH=H*H
      H10=XX1+HH
      H20=XX2+HH
      H02=YY2+HH
      H01=YY1+HH
      SH10=SQRT(H10)
      SH20=SQRT(H20)
      SH02=SQRT(H02)
      SH01=SQRT(H01)
      S11 =SQRT(XY11+HH)
      S12 =SQRT(XY12+HH)
      S22 =SQRT(XY22+HH)
      S21 =SQRT(XY21+HH)
      Y1S11=Y1+S11
      Y1S21=Y1+S21
      Y2S22=Y2+S22
      Y2S12=Y2+S12
      X1S11=X1+S11
      X1S12=X1+S12
      X2S22=X2+S22
      X2S21=X2+S21
      A=X1*ALOG((H10*T1)/(Y1S11*Y2S12))+X2*ALOG((H20*T2)/(Y1S21*Y2S22))
     1 +Y1*ALOG((H01*T3)/(X1S11*X2S21))+Y2*ALOG((H02*T4)/(X2S22*X1S12))
     2 +H*(ARSIN((H01+Y1*S11)/(SH01*Y1S11))+ARSIN((H01+Y1*S21)/(SH01
     3 *Y1S21))+ARSIN((H02+Y2*S22)/(SH02*Y2S22))+ARSIN((H02+Y2*S12)
     4 /(SH02*Y2S12))+2.0*(ATAN(X1/H)+ATAN(X2/H))-6.2831853)
      IF (ISTART .EQ. 2) GO TO 4
      A1=A
      IF (JTS .EQ. 0) RETURN
    2 ISTART=1
C VALUES FOR INTEGRAL TO (ELST-ELEV)
      H=H2
      GO TO 3
    4 A2=A
      RETURN
      END
      SUBROUTINE TRIANG(RC,IS)
C INWARD JOIN ALL THE WAY TO STATION LOCATION, USING AVERAGE OF
C TRIANGLES FROM ADJACENT BROADSIDE COMPARTMENTS (LINE ELEMENT) AND
C INCLINED PLANE IN CENTRAL COMPARTMENT.
      INTEGER*2 NUMS,INNER
      DIMENSION DY(4),GCEN(500),GRAV(500,13),GV(500),NUMS(500,13)
      COMMON /BLK2/ SLATM(500),SLONM(500),AS(500),BS(500),ELS(500),
     1 BREA(6),LTM(500),LNM(500)
      COMMON /MINUS/NEGLND
      COMMON /GIN/XC,YC,AC5,YS,YN,DY,   AREAB,GPA,GB,GBW,ARCSB,AC10
      COMMON /ELG/ELEV,ELST,RGR2,NGLD
      COMMON  /TRNG/AC53,BC53,DYN,DYS,AREAC,BC5,NEGTST
      COMMON RMIN,RMIN2,RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
C      COMMON  /INR/INNER(500)
      COMMON  /CPR/X1,X2,Y1,Y2,H1,H2,A1,A2,DXW,DXE,C,D,F,GS,AXC,BYC
      GS=0.0
      GC=0.0
      GW=0.0
C      JNR=INNER(IS)
      AXC=ABS(XC)
      IF (AC53 .LE. AXC) GO TO 37
      BYC=ABS(YC)
      IF (BC53 .LE. BYC) GO TO 37
      IF (DYN .EQ. 0.0) GO TO 37
      IF (DYS .EQ. 0.0) GO TO 37
      DXW=AXC-AC5
      IF (ABS(DXW) .LT. AC10) GO TO 37
      IF (BYC .GT. BC5) GO TO 61
      IF (AXC .GT. AC5) GO TO 62
C STATION INSIDE COMPARTMENT
      H=ABS(ELEV-ELST)
      Y1=BC5-BYC
      Y2=BC5+BYC
      X1=AC5-AXC
      X2=AC5+AXC
      A1=AC5+XC*XC/AC5
      A2=BC5+YC*YC/BC5
      IF (A2 .GT. A1) GO TO 23
      Y1=X1
      Y2=X2
      X1=BC5-BYC
      X2=BC5+BYC
      A1=A2
   23 TG=2.0*H/A1
C      INNER(IS)=JNR+1
      H2=H
      H1=ABS(ELST)
      A1=0.0
      A2=0.0
      IF (ELST .EQ. 0.0 .AND. NEGTST .EQ. -2) ELEV=ELS(IS)
      IF (ELEV .LT. 0.0) GO TO 24
      IF (H .EQ. 0.0) GO TO 26
C HALF OF VALUE UNLESS ALONG EDGE OF COMPARTMENT
      GC=CINCL(TG)*0.5
      IF (ELST .LT. 0.0) GO TO 25
   26 GW=1.027*GW
      GC=GC-GW/2.67
C      GCEN(IS)=GC*17.8089+GCEN(IS)
      GB=GB+GC/AREAB
      GBW=GBW+GW/AREAB
      RETURN
   25 IF (NEGLND .EQ. 1) GO TO 26
      T1=X1
      X1=H1/TG
      X2=X1
      CALL CPRISM(0)
      GW=CINCL(TG)-A1
      IF (T1 .EQ. 0.0) GW=0.5*GW
      GO TO 26
   27 GC=CINCL(TG)
      GO TO 26
   24 IF (NGLD   .EQ. 1) GO TO 27
      IF (ELST) 31,32,33
   31 IF (ELST-ELEV) 34,35,36
   32 IF (NEGTST .LT. 0) GO TO 28
      GC=CINCL(TG)
      GW=GC
      GO TO 26
   28 CALL CPRISM(1)
      GC=A2
      GW=A2
      GO TO 26
   33 T1=X1
      GC=CINCL(TG)
      CALL CPRISM(0)
      GW=-A1
      X1=H1/TG
      X2=X1
      CALL CPRISM(0)
      A1=A1-CINCL(TG)
      IF (T1 .EQ. 0.0) A1=0.5*A1
      GW=GW+A1+GC
      GO TO 26
   34 GC=CINCL(TG)
   35 CALL CPRISM(0)
      GW=GC-A1
      GO TO 26
   36 IF (NEGTST .LT. 0) GO TO 38
      GC=CINCL(TG)
      GO TO 35
   38 CALL CPRISM(2)
      GC=A2
      GW=A2-A1
      GO TO 26
C DIFFERENT ROW THAN STATION
   61 IF (AC5 .LE. AXC .OR. NEGTST .LT. 0) GO TO 37
C SAME COLUMN AS STATION, BROADSIDE
      C=BYC-BC5
      D=XC+AC5
      F=XC-AC5
      GO TO 63
C SAME ROW AS STATION, BROADSIDE
   62 IF (NEGTST .LT. 0) GO TO 37
      C=AXC-AC5
      D=YC+BC5
      F=YC-BC5
C TRIANGULAR JOIN IN CENTRAL COMPARTMENT WITH 4 BROADSIDES
C   63 INNER(IS)=JNR+1
   63 H=ABS(ELEV-ELST)
      IF(H .EQ. 0.0) RETURN
C FORMULAS FOR LAND ONLY
      RBAR2=(4.0*C*C+(D+F)*(D+F))/9.0
      TELEV=ELEV
      ELEV=ELST+SQRT(RBAR2/RC)*(ELEV-ELST)
      CALL GR(RBAR2,GC,GW)
C HALF OF VALUE
      ABAR=0.25*C*(D-F)
      ABAR=ABS(ABAR)/AREAB
      GC=GC*ABAR
      BIG=GC*17.8089
C      GCEN(IS)=GCEN(IS)+BIG
      GB=GB+GC/AREAB
      GS=GW*ABAR
      ELEV=TELEV
   37 CALL GR(RC,GC,GW)
      GB=GB+GC*ARCSB
      GBW=GBW+GW*ARCSB
      RETURN
      END
      FUNCTION CINCL(TG)
C DETERMINE EFFECT OF BROADSIDE-ORIENTED RECTANGULAR PRISM BOUNDED BY AN
C INCLINED PLANE THAT PASSES THROUGH ORIGIN (STATION). DIRECTION OF DIP
C IS X. SLOPE IS TG. X1 AND X2 ARE POSITIVE BUT ON BOTH SIDES OF ORIGIN
C (ADDITIVE). Y1 AND Y2 ARE POSITIVE AND ON EACH SIDE OF X-AXIS
C (ADDITIVE). X1=0 ALONG COMPARTMENT EDGE. MULTIPLY 2.67*6.667 OUTSIDE.
      COMMON  /CPR/X1,X2,Y1,Y2,DUM(12)
      COMMON  /TRAK/PP,P,XX1,XX2,YY2,YY1,T2,T4,C112,C221,C211,PX1,PX2,
     1 X1P,X2P,X2Y1,X2Y2,X1Y2,X1Y1,PX1Y1,PX1Y2,PX2Y2,PX2Y1,C321,C311,T6
     1 ,DU(4)
      PP=1.0+TG*TG
      P=SQRT(PP)
      XX2=X2*X2
      YY2=Y2*Y2
      T2=0.0
      T4=0.0
      T6=0.0
      C112=1.0
      C221=1.0
      C211=1.0
      C311=1.0
      C321=1.0
      PX2=PP*XX2
      X2P=X2*P
      X2Y2=SQRT(YY2+XX2)
      PX2Y2=SQRT(YY2+PX2)
      IF (Y1 .EQ. 0) GO TO 3
      YY1=Y1*Y1
      X2Y1=SQRT(YY1+XX2)
      PX2Y1=SQRT(YY1+PX2)
      C212=(X2+X2Y1)/Y1
      C312=Y1/(X2P+PX2Y1)
      C112=P*(Y1+X2Y1)/(Y1+PX2Y1)
    3 IF (X1 .EQ. 0) GO TO 2
      XX1=X1*X1
      PX1=PP*XX1
      X1P=X1*P
      X1Y2=SQRT(YY2+XX1)
      X1Y1=SQRT(YY1+XX1)
      PX1Y1=SQRT(YY1+PX1)
      PX1Y2=SQRT(YY2+PX1)
      C221=(X1+X1Y2)/Y2
      C321=Y2/(X1P+PX1Y2)
      T4=Y1*ALOG(C212*(X1+X1Y1)/Y1)
      T6=Y1*ALOG(C312*Y1/(X1P+PX1Y1))
      T2=X1*ALOG(PP*(Y1+X1Y1)*(Y2+X1Y2)/((Y1+PX1Y1)*(Y2+PX1Y2)))
    2 CINCL=X2*ALOG(C112*P*(Y2+X2Y2)/(Y2+PX2Y2))+T2+Y2*ALOG(C221*(X2+
     1 X2Y2)/Y2)+T4+(Y2*ALOG(C321*Y2/(X2P+PX2Y2))+T6)/P
      RETURN
      END
      SUBROUTINE CENTD(X1,X2,Y1,Y2,S1,S2,AREA,YM,XM,M)
      INTEGER*2 NUMS
      DIMENSION GRAV(500,13),NUMS(500,13),GV(500),GCEN(500)
      COMMON R,AA,      RMAX2,BL2K,BL2L,QB2B,QA2B,AQM,BQM,ST,SN,
     1 A,B,   GCEN,GRAV,GV,NUMS
C NOTE-COMMON STATEMENT NAMES ARE DIFFERENT THAN OTHER SUBROUTINES
C M-NUMBER OF CORNERS OUTSIDE COMPARTMENT (EXCEPT 5=3). ABSOLUTE VALUES
C GIVE PROTECTION AGAINST SQUARE ROOTS OF NEGATIVE NUMBERS MEANT TO BE 0
      GO TO (12,12,35,4,35,6), M
   12 AX2=ABS(X2)
      AY2=ABS(Y2)
      X22=X2*X2
      Y22=Y2*Y2
      AAX2=ABS(AA-X22)
      AAY2=AA-Y22
      SAX2=SQRT(AAX2)
      IF (M .EQ. 2) GO TO 2
C 1 CORNER OUTSIDE
    1 AAY2=ABS(AAY2)
      SAY2=SQRT(AAY2)
C FACTOR TERMS TO MINIMIZE LOSS OF SIGNIFICANT FIGURES
      AREA=AX2*(AY2-0.5*SAX2)-0.5*(AY2*SAY2+AA*(ARSIN(AX2/R)-ARSIN(SAY2/
     1 R)))
      YM=S1*(0.5*AY2*(Y22/3.0-AAX2)+AAX2*SAX2/3.0)
      XM=S2*(0.5*AX2*(X22/3.0-AAY2)+AAY2*SAY2/3.0)
      RETURN
C 2 CORNERS OUTSIDE-CONNECTED AREA
    2 SX=S1*X1
      X11=X1*X1
      AAX1=ABS(AA-X11)
      SAX1=SQRT(AAX1)
      AREA=AY2*(AX2-SX)-0.5*(AX2*SAX2-SX*SAX1+AA*(ARSIN(AX2/R)
     1 -ARSIN(SX/R)))
      YM=S1*(0.5*AY2*(X22-X11)+(AAX2*SAX2-AAX1*SAX1)/3.0)
      XM=0.5*S2*(AX2*(X22/3.0-AAY2)-SX*(X11/3.0-AAY2))
      RETURN
C 4 CORNERS OUTSIDE-CONNECTED INSIDE AREA USED
    4 AAY1=ABS(AA-Y1*Y1)
      SAY1=SQRT(AAY1)
      AREA=AA*ARSIN(SAY1/R)-ABS(Y1)*SAY1
      YM=0.0                                                                0310
      XM=0.6666667*S2*AAY1*SAY1
      RETURN
   35 AY1=ABS(Y1)
      X11=X1*X1
      Y11=Y1*Y1
      AAX1=ABS(AA-X11)
      AAY1=ABS(AA-Y11)
      SAX1=SQRT(AAX1)
      SAY1=SQRT(AAY1)
      IF (M .EQ. 5) GO TO 5
C 3 CORNERS OUTSIDE-1 CORNER INSIDE USED
    3 SX=S1*X1
      IF (SAY1 .EQ. SX) GO TO 10
      AREA=SX*(AY1-0.5*SAX1)-0.5*(AY1*SAY1-AA*(ARSIN(SAY1/R)-ARSIN(SX/R)
     1 ))
      YM=S1*(AAX1*SAX1/3.0+0.5*AY1*(Y11/3.0-AAX1))
      XM=S2*(AAY1*SAY1/3.0+0.5*SX*(X11/3.0-AAY1))
      RETURN
C CASE WHERE A CORNER IS ON CIRCLE AND WHOLE COMPARTMENT IS OUTSIDE
   10 AREA=0.0
      YM=0.0
      XM=0.0
      RETURN
C 3 CORNERS OUTSIDE-OCCUPIES 3 QUADRANTS (CLOSE-IN)
    5 AX1=ABS(X1)
      AX2=ABS(X2)
      AY2=ABS(Y2)
      X22=X2*X2
      Y22=Y2*Y2
      AREA=AX2*(AY1+AY2)+AX1*AY2-0.5*(AX1*SAX1+AY1*SAY1
     1 +AA*(1.570796+ARSIN(AX1/R)+ARSIN(AY1/R)))
      YM=S1*(0.5*(AY1*(Y11/3.0-AA+X22)+AY2*(X22-X11))-AAX1*SAX1/3.0)
      XM=S2*(0.5*(AX1*(X11/3.0-AA+Y22)+AX2*(Y22-Y11))-AAY1*SAY1/3.0)
      RETURN
C 3 CORNERS OUT, Y1=0.0
    6 SX=S1*X1
      X11=X1*X1
      AAX1=ABS(AA-X11)
      SAX1=SQRT(AAX1)
      AREA=0.5*(AA*(1.570796-ARSIN(SX/R))-SX*SAX1)
      YM=S1*AAX1*SAX1/3.0
      XM=S2*(AA*R/3.0+0.5*SX*(X11/3.0-AA))
      RETURN
      END                                                                   0340
      FUNCTION ARSIN(A)
      ARSIN=ASIN(A)
      RETURN
      END
      SUBROUTINE GETMAPS(LAT1,LON1,LAT2,LON2,IFLAG)
C
C   THIS SUBROUTINE WILL CREATE 3 TERRAIN DATA SETS IN THE USER'S
C    WORKING DIRECTORY, EXTENDING THE FOLLOWING DISTANCES FROM THE
C    SURVEY BOUNDS:
C
C       TERR1.TMP      0.0 -   5.0   KM.     15 SEC DATA    (IFLAG = 15)
C                                            30 SEC DATA    (IFLAG = 30)
C       TERR2.TMP    5.0   -  21.0   KM.      1 MIN DATA
C       TERR3.TMP      21. - 166.7   KM.      3 MIN DATA
C
      DIMENSION BNDS(3),TOLSX(3),TOLSY(3)
      DIMENSION ITYPES(2),LENGTHS(2),DATA(3610)
      CHARACTER*50 TERR_FILES(3)
      CHARACTER*6 IDTYPS(4)
      DATA TERR_FILES/'TERR1.TMP','TERR2.TMP','TERR3.TMP'/
      DATA IDTYPS/'15 SEC','30 SEC',' 1 MIN',' 3 MIN'/
      DATA BNDS/5.,21.,166.7/,RAD/.01745329/,YKMDEG/110.9466/
      DATA TOLSX/.25,.25,2.0/,TOLSY/.25,.25,1.0/
      LATUL=IABS(LAT1)
      LONUL=IABS(LON1)
      LATLR=IABS(LAT2)
      LONLR=IABS(LON2)
      ITYPES(1)=2
      ITYPES(2)=3
      LENGTHS(1)=900
      LENGTHS(2)=225
      IF(IFLAG.EQ.30) GO TO 3
      ITYPES(1)=1
      LENGTHS(1)=3600
    3 CALL CVTAN1(LATUL,FLT1)
      FLTR1=FLT1*RAD
      XKMDEG=YKMDEG*COS(FLTR1)
      CALL CVTAN1(LATLR,FLT2)
      CALL CVTAN1(LONUL,FLN1)
      CALL CVTAN1(LONLR,FLN2)
      DO 10 I=1,3
      XDEG=BNDS(I)/XKMDEG
      YDEG=BNDS(I)/YKMDEG
      TOLX=TOLSX(I)
      TOLY=TOLSY(I)
      FLTL=FLT2-YDEG
      FLTU=FLT1+YDEG+TOLY
      FLNR=FLN2-XDEG
      FLNL=FLN1+XDEG+TOLX
      CALL CVTAN2(FLTL,TOLY,LATL,LATDL,LATML)
      CALL CVTAN2(FLTU,TOLY,LATU,LATDU,LATMU)
      CALL CVTAN2(FLNR,TOLX,LONR,LONDR,LONMR)
      CALL CVTAN2(FLNL,TOLX,LONL,LONDL,LONML)
C     WRITE(6,5) YKMDEG,XKMDEG,YDEG,XDEG,FLT1,FLT2,FLN1,FLN2
C   5 FORMAT(2X,8F8.2)
C     WRITE(6,6) FLTL,FLTU,FLNR,FLNL,LATL,LATU,LONR,LONL
C   6 FORMAT(2X,4F8.2,4I10)
      IF(I.EQ.3) GO TO 101
      OPEN(UNIT=11,FILE=TERR_FILES(I),STATUS='UNKNOWN',
     & FORM='UNFORMATTED')
      ITYPE=ITYPES(I)
      LEN=LENGTHS(I)
      LATD=LATDU
      LATM=LATMU
      KLAT=LATU
   38 LOND=LONDL
      LONM=LONML
      KLON=LONL
   40 CALL READT(DATA,KLAT,KLON,ITYPE,IERR)
C     WRITE(6,39) KLAT,KLON,ITYPE
C  39 FORMAT(2X,'READING ',3I10)
      IF(IERR.EQ.0) GO TO 55
      WRITE(6,41) IDTYPS(ITYPE),KLAT,KLON
   41 FORMAT(2X,A6,' TERRAIN DATA BLOCK MISSING FOR (LAT,LON) = (',
     &I4,',',I5,')')
      GO TO 42
   55 CALL WRITEBIN(11,DATA,10)
      CALL WRITEBIN(11,DATA(11),LEN)
   42 LONM=LONM-15
      IF(LONM.GE.0) GO TO 58
      LONM=45
      LOND=LOND-1
   58 KLON=LOND*100+LONM
      IF(KLON.GT.LONR) GO TO 40
      LATM=LATM-15
      IF(LATM.GE.0) GO TO 60
      LATM=45
      LATD=LATD-1
   60 KLAT=LATD*100+LATM
      IF(KLAT.GT.LATL) GO TO 38
      CLOSE(11)
      CALL CLOSET(ITYPE)
      GO TO 10
  101 OPEN(UNIT=11,FILE=TERR_FILES(3),STATUS='UNKNOWN',
     & FORM='UNFORMATTED')
      KLAT=LATU
  130 KLON=LONL
  140 CALL READT(DATA,KLAT,KLON,4,IERR)
C     WRITE(6,39) KLAT,KLON,ITYPE
      IF(IERR.EQ.0) GO TO 155
      WRITE(6,41) IDTYPS(4),KLAT,KLON
      GO TO 157
  155 CALL WRITEBIN(11,DATA,10)
      CALL WRITEBIN(11,DATA(11),800)
  157 KLON=KLON-200
      IF(KLON.GT.LONR) GO TO 140
      KLAT=KLAT-100
      IF(KLAT.GT.LATL) GO TO 130
      CLOSE(11)
      CALL CLOSET(4)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE WRITEBIN(IUN,DATA,LEN)
      DIMENSION DATA(LEN)
      WRITE(IUN) DATA
      RETURN
      END
      SUBROUTINE CVTAN1(IANG,ANG)
      DEG=IANG/100
      FMIN=MOD(IANG,100)
      ANG=DEG+FMIN/60.
      RETURN
      END
      SUBROUTINE CVTAN2(ANG,TOL,IVAL,IDEG,MIN)
      ITOL=TOL*100.
      IDEG=ANG*100.
      DEG=IDEG/ITOL*ITOL
      DEG=DEG/100.
      IDEG=DEG
      MIN=(DEG-IDEG)*60.
      IVAL=IDEG*100+MIN
      RETURN
      END
