      subroutine openterr(itype,mode)
      external bdterr
      integer*4 itype,mode,ierr,iunit(6),lenrec(6)
      character*50 terrfil(6)
      logical isopen(6)
      common/terrinit/iunit,isopen,terrfil
      data lenrec/1808,458,120,408,458,20/
      ierr=0
      if(mode.eq.1) then
c
c   Open for read only.
c
      open(unit=iunit(itype),file=terrfil(itype),status='old',
     1organization='indexed',access='keyed',recordtype='fixed',
     2form='unformatted',recl=lenrec(itype),key=(1:4:integer),
     3readonly,iostat=ierr,err=999)
c
      else
c
c   Open for read/write.  If file doesn't exist, it will be created.
c
      open(unit=iunit(itype),file=terrfil(itype),status='unknown',
     1organization='indexed',access='keyed',recordtype='fixed',
     2form='unformatted',recl=lenrec(itype),key=(1:4:integer),shared,
     3iostat=ierr,err=999)
c
      end if
      isopen(itype)=.true.
      return
c
  999 write(6,1000) terrfil(itype),ierr
 1000 format(1x,'Error in opening terrain file',/,7x,
     1'(',a50,').  IOS = ',i3)
      stop
      end
      subroutine closeterr(itype)
      integer*4 itype,iunit(6)
      character*50 terrfil(6)
      logical isopen(6)
      common/terrinit/iunit,isopen,terrfil
      if(itype.gt.0.and.itype.lt.7) then
c
      if(isopen(itype)) then
      close(iunit(itype))
      isopen(itype)=.false.
      end if
c
      else
c
      do 10 i=1,6
      if(isopen(i)) then
      close(iunit(i))
      isopen(i)=.false.
      end if
   10 continue
c
      end if
      return
      end
      subroutine writerr(idata,lat,lon,itype,ierr)
      integer*4 idata(*),ihdr(3),limits(6)
      integer*4 lat,lon,itype,ierr,len
      integer*4 inhdr(10),idata1(450),idata2(450)
      integer*2 idatah(3614)
      equivalence (idatah(1),ihdr(1))
      data limits/3613,913,238,813,913,38/
      len=limits(itype)
      ihdr(1)=idata(1)
      ihdr(2)=idata(2)
      ihdr(3)=idata(3)
      in=4
      do 10 i=7,len
      idatah(i)=idata(in)
      in=in+1
   10 continue
      call wrterr(idatah,len,lat,lon,itype,ierr)
      return
c
      entry fwriterr(idata,lat,lon,itype,ierr)
      len=limits(itype)
      ihdr(1)=idata(1)
      ihdr(2)=idata(2)
      ihdr(3)=idata(3)
      in=4
      do 20 i=7,len
      idatah(i)=idata(in)
      in=in+1
   20 continue
      call fwrterr(idatah,len,lat,lon,itype,ierr)
      return
c
      entry readterr(idata,lat,lon,itype,ierr)
      len=limits(itype)
      call rdterr(idatah,len,lat,lon,itype,ierr)
      idata(1)=ihdr(1)
      idata(2)=ihdr(2)
      idata(3)=ihdr(3)
      in=4
      do 30 i=7,len
      idata(in)=idatah(i)
      in=in+1
   30 continue
      return
c
      entry updaterr(idata,lat,lon,itype,ierr)
      len=limits(itype)
      ihdr(1)=idata(1)
      ihdr(2)=idata(2)
      ihdr(3)=idata(3)
      in=4
      do 40 i=7,len
      idatah(i)=idata(in)
      in=in+1
   40 continue
      call udterr(idatah,len,lat,lon,itype,ierr)
      return
c
      entry writerrin(inhdr,idata1,idata2,lat,lon,itype,ierr)
      len=limits(itype)
      ihdr(1)=inhdr(1)
      ihdr(2)=inhdr(2)
      ihdr(3)=inhdr(3)
      in=7
      do 50 i=4,10
      idatah(in)=inhdr(i)
      in=in+1
   50 continue
      in2=in+450
      do 60 i=1,450
      idatah(in)=idata1(i)
      idatah(in2)=idata2(i)
      in=in+1
      in2=in2+1
   60 continue
      call wrterr(idatah,len,lat,lon,itype,ierr)
      return
      end
      subroutine wrterr(data,len,lat,lon,itype,ierr)
      include '($foriosdef)'
      integer*4 iunit(6)
      integer*4 lat,lon,itype,ierr,keyll
      integer*4 len,mode1,mode2,ios
      integer*2 data(len)
      character*50 terrfil(6)
      logical isopen(6)
      common/terrinit/iunit,isopen,terrfil
      data mode1/1/,mode2/2/
      iskey(i,j)=i*100000+j
      if(.not.isopen(itype)) call openterr(itype,mode2)
      ierr=0
      keyll=iskey(lat,lon)
      write(iunit(itype),iostat=ios,err=999) keyll,data
      return
c
      entry fwrterr(data,len,lat,lon,itype,ierr)
      if(.not.isopen(itype)) call openterr(itype,mode2)
      ierr=0
      keyll=iskey(lat,lon)
      read(iunit(itype),key=keyll,iostat=ios,err=10)
      rewrite(iunit(itype),iostat=ios,err=999) keyll,data
      return
   10 if(ios.ne.for$ios_attaccnon) go to 999
      write(iunit(itype),iostat=ios,err=999) keyll,data
      return
c
      entry rdterr(data,len,lat,lon,itype,ierr)
      if(.not.isopen(itype)) call openterr(itype,mode1)
      ierr=0
      keyll=iskey(lat,lon)
      read(iunit(itype),key=keyll,iostat=ios,err=999) keyll,data
      unlock(iunit(itype),iostat=ios,err=999)
      return
c
      entry udterr(data,len,lat,lon,itype,ierr)
      if(.not.isopen(itype)) call openterr(itype,mode2)
      ierr=0
      keyll=iskey(lat,lon)
      read(iunit(itype),key=keyll,iostat=ios,err=999)
      rewrite(iunit(itype),iostat=ios,err=999) keyll,data
      return
c
      entry deleterr(lat,lon,itype,ierr)
      if(.not.isopen(itype)) call openterr(itype,mode2)
      ierr=0
      keyll=iskey(lat,lon)
      read(iunit(itype),key=keyll,iostat=ios,err=999)
      delete(iunit(itype),iostat=ios,err=999)
      return
  999 write(6,1000) terrfil(itype),keyll,ios
 1000 format(1x,'Error in accessing terrain file',/,7x,
     1'(',a32,'). KEY = ',I14,'  IOSTAT = ',i3)
 1001 ierr=ios
      return
      end
      block data bdterr
      integer*4 iunit(6)
      character*50 terrfil(6)
      logical isopen(6)
      common/terrinit/iunit,isopen,terrfil
      data iunit/34,35,36,37,38,39/
      data isopen/6*.false./
      data terrfil/'data$disk:[terrain]15sec.dat',
     1             'data$disk:[terrain]30sec.dat',
     1             'data$disk:[terrain]1min.dat',
     1             'data$disk:[terrain]3min.dat',
     1             'data$disk:[terrain]30secinit.dat',
     1             'data$disk:[terrain]3mininit.dat'/
      end
