c
c         program to write to disk selected parts of terrain data
c         for the purpose of transferring to a PC.
c
c
          write(*,100)
100       format(' enter lower right lat & long boundary of data',
     &    '(deg & nearest 15 min)',/,'$ : ')
          read(*,*) latbd,latbm,lonbd,lonbm
          write(*,200)
200       format(' enter upper left lat & long boundary of data',
     &    '(deg & nearest 15 min)',/,'$ : ')
          read(*,*) latud,latum,lonud,lonum
10        write(*,300)
300       format(' enter inner terrain data spacing(15 or 30)',/,'$ : ')
          read(*,*) inn
          if(inn.ne.15.and.inn.ne.30) then
          print *,' answer must be 15 or 30'
          go to 10
          endif
          lat1=latud*100 + latum
          lon1=lonud*100 + lonum
          lat2=latbd*100 + latbm
         lon2=lonbd*100 + lonbm
          call getmaps(lat1,lon1,lat2,lon2,inn)
          stop
          end
      SUBROUTINE GETMAPS(LAT1,LON1,LAT2,LON2,IFLAG)
C
C   THIS SUBROUTINE WILL CREATE 3 TERRAIN DATA SETS IN THE USER'S
C    WORKING DIRECTORY, EXTENDING THE FOLLOWING DISTANCES FROM THE
C    SURVEY BOUNDS:
C
C       INNER.TER      0.0 -   5.0   KM.     15 SEC DATA    (IFLAG = 15)
C                                            30 SEC DATA    (IFLAG = 30)
C       1MIN.TER    5.0   -  21.0   KM.      1 MIN DATA
C       3MIN.TER      21. - 166.7   KM.      3 MIN DATA
C
      DIMENSION BNDS(3),TOLSX(3),TOLSY(3),LIMITS(4)
      INTEGER ITYPES(2),LENGTHS(2),DATA(3610)
      CHARACTER*12 IFMT
      CHARACTER*50 TERR_FILES(4)
      CHARACTER*6 IDTYPS(4)
      DATA TERR_FILES/'15SEC.TER','30SEC.TER','1MIN.TER','3MIN.TER'/
      DATA IDTYPS/'15 SEC','30 SEC',' 1 MIN',' 3 MIN'/
      DATA BNDS/5.,21.,166.7/,RAD/.01745329/,YKMDEG/110.9466/
      DATA TOLSX/.25,.25,2.0/,TOLSY/.25,.25,1.0/
      DATA LIMITS/3607,907,232,807/
      LATUL=IABS(LAT1)
      LONUL=IABS(LON1)
      LATLR=IABS(LAT2)
      LONLR=IABS(LON2)
      ITYPES(1)=2
      ITYPES(2)=3
      LENGTHS(1)=900
      LENGTHS(2)=225
      IF(IFLAG.EQ.30) GO TO 3
      ITYPES(1)=1
      LENGTHS(1)=3600
    3 CALL CVTANG1(LATUL,FLT1)
      FLTR1=FLT1*RAD
      XKMDEG=YKMDEG*COS(FLTR1)
      CALL CVTANG1(LATLR,FLT2)
      CALL CVTANG1(LONUL,FLN1)
      CALL CVTANG1(LONLR,FLN2)
      DO 10 I=1,3
      XDEG=BNDS(I)/XKMDEG
      YDEG=BNDS(I)/YKMDEG
      TOLX=TOLSX(I)
      TOLY=TOLSY(I)
      FLTL=FLT2-YDEG
      FLTU=FLT1+YDEG+TOLY
      FLNR=FLN2-XDEG
      FLNL=FLN1+XDEG+TOLX
      CALL CVTANG2(FLTL,TOLY,LATL,LATDL,LATML)
      CALL CVTANG2(FLTU,TOLY,LATU,LATDU,LATMU)
      CALL CVTANG2(FLNR,TOLX,LONR,LONDR,LONMR)
      CALL CVTANG2(FLNL,TOLX,LONL,LONDL,LONML)
C     WRITE(6,5) YKMDEG,XKMDEG,YDEG,XDEG,FLT1,FLT2,FLN1,FLN2
C   5 FORMAT(2X,8F8.2)
C     WRITE(6,6) FLTL,FLTU,FLNR,FLNL,LATL,LATU,LONR,LONL
C   6 FORMAT(2X,4F8.2,4I10)
      IF(I.EQ.3) GO TO 101
      ITYPE=ITYPES(I)
      LEN=LENGTHS(I)+10
      WRITE(IFMT,20) '(3A4,',LIMITS(ITYPE),'I4)'
   20 FORMAT(A,I4,A)
      LENREC=12+4*LIMITS(ITYPE)
      OPEN(UNIT=11,FILE=TERR_FILES(ITYPE),STATUS='NEW',
     & RECORDTYPE='FIXED',CARRIAGECONTROL='LIST',RECL=LENREC)
      LATD=LATDU
      LATM=LATMU
      KLAT=LATU
   38 LOND=LONDL
      LONM=LONML
      KLON=LONL
   40 CALL READTERR(DATA,KLAT,KLON,ITYPE,IERR)
C     WRITE(6,39) KLAT,KLON,ITYPE
C  39 FORMAT(2X,'READING ',3I10)
      IF(IERR.EQ.0) GO TO 55
      WRITE(6,41) IDTYPS(ITYPE),KLAT,KLON
   41 FORMAT(2X,A6,' TERRAIN DATA BLOCK MISSING FOR (LAT,LON) = (',
     &I4,',',I5,')')
      GO TO 42
   55 WRITE(11,IFMT) (DATA(J),J=1,LEN)
   42 LONM=LONM-15
      IF(LONM.GE.0) GO TO 58
      LONM=45
      LOND=LOND-1
   58 KLON=LOND*100+LONM
      IF(KLON.GT.LONR) GO TO 40
      LATM=LATM-15
      IF(LATM.GE.0) GO TO 60
      LATM=45
      LATD=LATD-1
   60 KLAT=LATD*100+LATM
      IF(KLAT.GT.LATL) GO TO 38
      CLOSE(11)
      CALL CLOSETERR(ITYPE)
      GO TO 10
  101 WRITE(IFMT,20) '(3A4,',LIMITS(4),'I4)'
      LENREC=12+4*LIMITS(4)
      OPEN(UNIT=11,FILE=TERR_FILES(4),STATUS='NEW',RECORDTYPE='FIXED',
     & CARRIAGECONTROL='LIST',RECL=LENREC)
      KLAT=LATU
  130 KLON=LONL
  140 CALL READTERR(DATA,KLAT,KLON,4,IERR)
C     WRITE(6,39) KLAT,KLON,ITYPE
      IF(IERR.EQ.0) GO TO 155
      WRITE(6,41) IDTYPS(4),KLAT,KLON
      GO TO 157
  155 WRITE(11,IFMT) (DATA(J),J=1,810)
  157 KLON=KLON-200
      IF(KLON.GT.LONR) GO TO 140
      KLAT=KLAT-100
      IF(KLAT.GT.LATL) GO TO 130
      CLOSE(11)
      CALL CLOSETERR(4)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CVTANG1(IANG,ANG)
      DEG=IANG/100
      FMIN=MOD(IANG,100)
      ANG=DEG+FMIN/60.
      RETURN
      END
      SUBROUTINE CVTANG2(ANG,TOL,IVAL,IDEG,MIN)
      ITOL=TOL*100.
      IDEG=ANG*100.
      DEG=IDEG/ITOL*ITOL
      DEG=DEG/100.
      IDEG=DEG
      MIN=(DEG-IDEG)*60.
      IVAL=IDEG*100+MIN
      RETURN
      END
